searchData={"items":[{"type":"module","title":"GoogleApi.ServiceUsage.V1","doc":"API client metadata for GoogleApi.ServiceUsage.V1.","ref":"GoogleApi.ServiceUsage.V1.html"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.discovery_revision/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Api.Operations","doc":"API calls for all endpoints tagged `Operations`.","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_delete/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_get/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_list/3","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_list/3"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_list/3","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:name` (*type:* `String.t`) - The name of the operation's parent resource.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_list/3-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Operations.serviceusage_operations_list/3","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Operations.html#serviceusage_operations_list/3-returns"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Api.Services","doc":"API calls for all endpoints tagged `Services`.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_batch_enable/4","doc":"Enable multiple services on a project. The operation is atomic: if enabling any service fails, then the entire batch fails, and no state changes occur. To enable a single service, use the `EnableService` method instead.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_batch_enable/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_batch_enable/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Parent to enable services on. An example name would be: `projects/123` where `123` is the project number. The `BatchEnableServices` method currently only supports projects.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_batch_enable/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_batch_enable/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_batch_enable/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_batch_get/4","doc":"Returns the service configurations and enabled states for a given list of services.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_batch_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_batch_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Parent to retrieve services from. If this is set, the parent of all of the services specified in `names` must match this field. An example name would be: `projects/123` where `123` is the project number. The `BatchGetServices` method currently only supports projects.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:names` (*type:* `list(String.t)`) - Names of the services to retrieve. An example name would be: `projects/123/services/serviceusage.googleapis.com` where `123` is the project number. A single request can get a maximum of 30 services at a time.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_batch_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_batch_get/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_batch_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_disable/4","doc":"Disable a service so that it can no longer be used with a project. This prevents unintended usage that may cause unexpected billing charges or security leaks. It is not valid to call the disable method on a service that is not currently enabled. Callers will receive a `FAILED_PRECONDITION` status if the target service is not currently enabled.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_disable/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_disable/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Name of the consumer and service to disable the service on. The enable and disable methods currently only support projects. An example name would be: `projects/123/services/serviceusage.googleapis.com` where `123` is the project number.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_disable/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_disable/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_disable/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_enable/4","doc":"Enable a service so that it can be used with a project.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_enable/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_enable/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Name of the consumer and service to enable the service on. The `EnableService` and `DisableService` methods currently only support projects. Enabling a service requires that the service is public or is shared with the user enabling the service. An example name would be: `projects/123/services/serviceusage.googleapis.com` where `123` is the project number.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_enable/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_enable/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_enable/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_get/4","doc":"Returns the service configuration and enabled state for a given service.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Name of the consumer and service to get the `ConsumerState` for. An example name would be: `projects/123/services/serviceusage.googleapis.com` where `123` is the project number.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_get/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_list/4","doc":"List all services available to the specified project, and the current state of those services with respect to the project. The list includes all public services, all services for which the calling user has the `servicemanagement.services.bind` permission, and all services that have already been enabled on the project. The list can be filtered to only include services in a specific state, for example to only include services enabled on the project. WARNING: If you need to query enabled services frequently or across an organization, you should use [Cloud Asset Inventory API](https://cloud.google.com/asset-inventory/docs/apis), which provides higher throughput and richer filtering capability.","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_list/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_list/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceUsage.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Parent to search for services on. An example name would be: `projects/123` where `123` is the project number.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - Only list services that conform to the given filter. The allowed filter strings are `state:ENABLED` and `state:DISABLED`.\n    *   `:pageSize` (*type:* `integer()`) - Requested size of the next page of data. Requested page size cannot exceed 200. If not set, the default page size is 50.\n    *   `:pageToken` (*type:* `String.t`) - Token identifying which result to start with, which is returned by a previous list call.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Api.Services.serviceusage_services_list/4","doc":"*   `{:ok, %GoogleApi.ServiceUsage.V1.Model.ListServicesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceUsage.V1.Api.Services.html#serviceusage_services_list/4-returns"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Connection","doc":"Handle Tesla connections for GoogleApi.ServiceUsage.V1.","ref":"GoogleApi.ServiceUsage.V1.Connection.html"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.ServiceUsage.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.ServiceUsage.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.ServiceUsage.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceUsage.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.ServiceUsage.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.ServiceUsage.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.ServiceUsage.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceUsage.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceUsage.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceUsage.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceUsage.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceUsage.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceUsage.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceUsage.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceUsage.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.ServiceUsage.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.ServiceUsage.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.ServiceUsage.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.ServiceUsage.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.ServiceUsage.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceUsage.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.ServiceUsage.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Connection.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata","doc":"Metadata for the `AddEnableRules` method.","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse","doc":"The response message of `AddEnableRules` method.","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse","doc":"*   `addedValues` (*type:* `list(String.t)`, *default:* `nil`) - The values added to the parent consumer policy.\n*   `parent` (*type:* `String.t`, *default:* `nil`) - The parent consumer policy. It can be `projects/12345/consumerPolicies/default`, or `folders/12345/consumerPolicies/default`, or `organizations/12345/consumerPolicies/default`.","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AddEnableRulesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy","doc":"Quota policy created by quota administrator.","ref":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy","doc":"*   `container` (*type:* `String.t`, *default:* `nil`) - The cloud resource container at which the quota policy is created. The format is `{container_type}/{container_number}`\n*   `dimensions` (*type:* `map()`, *default:* `nil`) -  If this map is nonempty, then this policy applies only to specific values for dimensions defined in the limit unit. For example, a policy on a limit with the unit `1/{project}/{region}` could contain an entry with the key `region` and the value `us-east-1`; the policy is only applied to quota consumed in that region. This map has the following restrictions: * If `region` appears as a key, its value must be a valid Cloud region. * If `zone` appears as a key, its value must be a valid Cloud zone. * Keys other than `region` or `zone` are not valid.\n*   `metric` (*type:* `String.t`, *default:* `nil`) - The name of the metric to which this policy applies. An example name would be: `compute.googleapis.com/cpus`\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the policy. This name is generated by the server when the policy is created. Example names would be: `organizations/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/adminQuotaPolicies/4a3f2c1d`\n*   `policyValue` (*type:* `String.t`, *default:* `nil`) - The quota policy value. Can be any nonnegative integer, or -1 (unlimited quota).\n*   `unit` (*type:* `String.t`, *default:* `nil`) - The limit unit of the limit to which this policy applies. An example unit would be: `1/{project}/{region}` Note that `{project}` and `{region}` are not placeholders in this example; the literal characters `{` and `}` occur in the string.","ref":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Api","doc":"Api is a light-weight descriptor for an API Interface. Interfaces are also described as \"protocol buffer services\" in some contexts, such as by the \"service\" keyword in a .proto file, but they are different from API Services, which represent a concrete implementation of an interface as opposed to simply a description of methods and bindings. They are also sometimes simply referred to as \"APIs\" in other contexts, such as the name of this message itself. See https://cloud.google.com/apis/design/glossary for detailed terminology.","ref":"GoogleApi.ServiceUsage.V1.Model.Api.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Api","doc":"*   `methods` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Method.t)`, *default:* `nil`) - The methods of this interface, in unspecified order.\n*   `mixins` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Mixin.t)`, *default:* `nil`) - Included interfaces. See Mixin.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The fully qualified name of this interface, including package name followed by the interface's simple name.\n*   `options` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Option.t)`, *default:* `nil`) - Any metadata attached to the interface.\n*   `sourceContext` (*type:* `GoogleApi.ServiceUsage.V1.Model.SourceContext.t`, *default:* `nil`) - Source context for the protocol buffer service represented by this message.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax of the service.\n*   `version` (*type:* `String.t`, *default:* `nil`) - A version string for this interface. If specified, must have the form `major-version.minor-version`, as in `1.10`. If the minor version is omitted, it defaults to zero. If the entire version field is empty, the major version is derived from the package name, as outlined below. If the field is not empty, the version in the package name will be verified to be consistent with what is provided here. The versioning schema uses [semantic versioning](http://semver.org) where the major version number indicates a breaking change and the minor version an additive, non-breaking change. Both version numbers are signals to users what to expect from different versions, and should be carefully chosen based on the product plan. The major version is also reflected in the package name of the interface, which must end in `v`, as in `google.feature.v1`. For major versions 0 and 1, the suffix can be omitted. Zero major versions must only be used for experimental, non-GA interfaces.","ref":"GoogleApi.ServiceUsage.V1.Model.Api.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Api.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Api.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Api.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Api.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.AuthProvider","doc":"Configuration for an authentication provider, including support for [JSON Web Token (JWT)](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32).","ref":"GoogleApi.ServiceUsage.V1.Model.AuthProvider.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.AuthProvider","doc":"*   `audiences` (*type:* `String.t`, *default:* `nil`) - The list of JWT [audiences](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32#section-4.1.3). that are allowed to access. A JWT containing any of these audiences will be accepted. When this setting is absent, JWTs with audiences: - \"https://[service.name]/[google.protobuf.Api.name]\" - \"https://[service.name]/\" will be accepted. For example, if no audiences are in the setting, LibraryService API will accept JWTs with the following audiences: - https://library-example.googleapis.com/google.example.library.v1.LibraryService - https://library-example.googleapis.com/ Example: audiences: bookstore_android.apps.googleusercontent.com, bookstore_web.apps.googleusercontent.com\n*   `authorizationUrl` (*type:* `String.t`, *default:* `nil`) - Redirect URL if JWT token is required but not present or is expired. Implement authorizationUrl of securityDefinitions in OpenAPI spec.\n*   `id` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the auth provider. It will be referred to by `AuthRequirement.provider_id`. Example: \"bookstore_auth\".\n*   `issuer` (*type:* `String.t`, *default:* `nil`) - Identifies the principal that issued the JWT. See https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32#section-4.1.1 Usually a URL or an email address. Example: https://securetoken.google.com Example: 1234567-compute@developer.gserviceaccount.com\n*   `jwksUri` (*type:* `String.t`, *default:* `nil`) - URL of the provider's public key set to validate signature of the JWT. See [OpenID Discovery](https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata). Optional if the key set document: - can be retrieved from [OpenID Discovery](https://openid.net/specs/openid-connect-discovery-1_0.html) of the issuer. - can be inferred from the email domain of the issuer (e.g. a Google service account). Example: https://www.googleapis.com/oauth2/v1/certs\n*   `jwtLocations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.JwtLocation.t)`, *default:* `nil`) - Defines the locations to extract the JWT. For now it is only used by the Cloud Endpoints to store the OpenAPI extension [x-google-jwt-locations] (https://cloud.google.com/endpoints/docs/openapi/openapi-extensions#x-google-jwt-locations) JWT locations can be one of HTTP headers, URL query parameters or cookies. The rule is that the first match wins. If not specified, default to use following 3 locations: 1) Authorization: Bearer 2) x-goog-iap-jwt-assertion 3) access_token query parameter Default locations can be specified as followings: jwt_locations: - header: Authorization value_prefix: \"Bearer \" - header: x-goog-iap-jwt-assertion - query: access_token","ref":"GoogleApi.ServiceUsage.V1.Model.AuthProvider.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.AuthProvider.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.AuthProvider.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.AuthProvider.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AuthProvider.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement","doc":"User-defined authentication requirements, including support for [JSON Web Token (JWT)](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32).","ref":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.AuthRequirement","doc":"*   `audiences` (*type:* `String.t`, *default:* `nil`) - NOTE: This will be deprecated soon, once AuthProvider.audiences is implemented and accepted in all the runtime components. The list of JWT [audiences](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32#section-4.1.3). that are allowed to access. A JWT containing any of these audiences will be accepted. When this setting is absent, only JWTs with audience \"https://Service_name/API_name\" will be accepted. For example, if no audiences are in the setting, LibraryService API will only accept JWTs with the following audience \"https://library-example.googleapis.com/google.example.library.v1.LibraryService\". Example: audiences: bookstore_android.apps.googleusercontent.com, bookstore_web.apps.googleusercontent.com\n*   `providerId` (*type:* `String.t`, *default:* `nil`) - id from authentication provider. Example: provider_id: bookstore_auth","ref":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AuthRequirement.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Authentication","doc":"`Authentication` defines the authentication configuration for API methods provided by an API service. Example: name: calendar.googleapis.com authentication: providers: - id: google_calendar_auth jwks_uri: https://www.googleapis.com/oauth2/v1/certs issuer: https://securetoken.google.com rules: - selector: \"*\" requirements: provider_id: google_calendar_auth - selector: google.calendar.Delegate oauth: canonical_scopes: https://www.googleapis.com/auth/calendar.read","ref":"GoogleApi.ServiceUsage.V1.Model.Authentication.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Authentication","doc":"*   `providers` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.AuthProvider.t)`, *default:* `nil`) - Defines a set of authentication providers that a service supports.\n*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.t)`, *default:* `nil`) - A list of authentication rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceUsage.V1.Model.Authentication.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Authentication.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Authentication.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Authentication.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Authentication.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule","doc":"Authentication rules for the service. By default, if a method has any authentication requirements, every request must include a valid credential matching one of the requirements. It's an error to include more than one kind of credential in a single request. If a method doesn't have any auth requirements, request credentials will be ignored.","ref":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.AuthenticationRule","doc":"*   `allowWithoutCredential` (*type:* `boolean()`, *default:* `nil`) - If true, the service accepts API keys without any other credential. This flag only applies to HTTP and gRPC requests.\n*   `oauth` (*type:* `GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.t`, *default:* `nil`) - The requirements for OAuth credentials.\n*   `requirements` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.AuthRequirement.t)`, *default:* `nil`) - Requirements for additional authentication providers.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.AuthenticationRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Backend","doc":"`Backend` defines the backend configuration for a service.","ref":"GoogleApi.ServiceUsage.V1.Model.Backend.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Backend","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.BackendRule.t)`, *default:* `nil`) - A list of API backend rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceUsage.V1.Model.Backend.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Backend.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Backend.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Backend.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Backend.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BackendRule","doc":"A backend rule provides configuration for an individual API element.","ref":"GoogleApi.ServiceUsage.V1.Model.BackendRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BackendRule","doc":"*   `address` (*type:* `String.t`, *default:* `nil`) - The address of the API backend. The scheme is used to determine the backend protocol and security. The following schemes are accepted: SCHEME PROTOCOL SECURITY http:// HTTP None https:// HTTP TLS grpc:// gRPC None grpcs:// gRPC TLS It is recommended to explicitly include a scheme. Leaving out the scheme may cause constrasting behaviors across platforms. If the port is unspecified, the default is: - 80 for schemes without TLS - 443 for schemes with TLS For HTTP backends, use protocol to specify the protocol version.\n*   `deadline` (*type:* `float()`, *default:* `nil`) - The number of seconds to wait for a response from a request. The default varies based on the request protocol and deployment environment.\n*   `disableAuth` (*type:* `boolean()`, *default:* `nil`) - When disable_auth is true, a JWT ID token won't be generated and the original \"Authorization\" HTTP header will be preserved. If the header is used to carry the original token and is expected by the backend, this field must be set to true to preserve the header.\n*   `jwtAudience` (*type:* `String.t`, *default:* `nil`) - The JWT audience is used when generating a JWT ID token for the backend. This ID token will be added in the HTTP \"authorization\" header, and sent to the backend.\n*   `minDeadline` (*type:* `float()`, *default:* `nil`) - Deprecated, do not use.\n*   `operationDeadline` (*type:* `float()`, *default:* `nil`) - The number of seconds to wait for the completion of a long running operation. The default is no deadline.\n*   `overridesByRequestProtocol` (*type:* `%{optional(String.t) => GoogleApi.ServiceUsage.V1.Model.BackendRule.t}`, *default:* `nil`) - The map between request protocol and the backend address.\n*   `pathTranslation` (*type:* `String.t`, *default:* `nil`) - \n*   `protocol` (*type:* `String.t`, *default:* `nil`) - The protocol used for sending a request to the backend. The supported values are \"http/1.1\" and \"h2\". The default value is inferred from the scheme in the address field: SCHEME PROTOCOL http:// http/1.1 https:// http/1.1 grpc:// h2 grpcs:// h2 For secure HTTP backends (https://) that support HTTP/2, set this field to \"h2\" for improved performance. Configuring this field to non-default values is only supported for secure HTTP backends. This field will be ignored for all other backends. See https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids for more details on the supported values.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.BackendRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BackendRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BackendRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BackendRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BackendRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse","doc":"Response message for BatchCreateAdminOverrides","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse","doc":"*   `overrides` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.QuotaOverride.t)`, *default:* `nil`) - The overrides that were created.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateAdminOverridesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse","doc":"Response message for BatchCreateConsumerOverrides","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse","doc":"*   `overrides` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.QuotaOverride.t)`, *default:* `nil`) - The overrides that were created.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BatchCreateConsumerOverridesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest","doc":"Request message for the `BatchEnableServices` method.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest","doc":"*   `serviceIds` (*type:* `list(String.t)`, *default:* `nil`) - The identifiers of the services to enable on the project. A valid identifier would be: serviceusage.googleapis.com Enabling services requires that each service is public or is shared with the user enabling the service. A single request can enable a maximum of 20 services at a time. If more than 20 services are specified, the request will fail, and no state changes will occur.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse","doc":"Response message for the `BatchEnableServices` method. This response message is assigned to the `response` field of the returned Operation when that operation is done.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse","doc":"*   `failures` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.EnableFailure.t)`, *default:* `nil`) - If allow_partial_success is true, and one or more services could not be enabled, this field contains the details about each failure.\n*   `services` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.t)`, *default:* `nil`) - The new state of the services after enabling.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BatchEnableServicesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse","doc":"Response message for the `BatchGetServices` method.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse","doc":"*   `services` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.t)`, *default:* `nil`) - The requested Service states.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BatchGetServicesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Billing","doc":"Billing related configuration of the service. The following example shows how to configure monitored resources and metrics for billing, `consumer_destinations` is the only supported destination and the monitored resources need at least one label key `cloud.googleapis.com/location` to indicate the location of the billing usage, using different monitored resources between monitoring and billing is recommended so they can be evolved independently: monitored_resources: - type: library.googleapis.com/billing_branch labels: - key: cloud.googleapis.com/location description: | Predefined label to support billing location restriction. - key: city description: | Custom label to define the city where the library branch is located in. - key: name description: Custom label to define the name of the library branch. metrics: - name: library.googleapis.com/book/borrowed_count metric_kind: DELTA value_type: INT64 unit: \"1\" billing: consumer_destinations: - monitored_resource: library.googleapis.com/billing_branch metrics: - library.googleapis.com/book/borrowed_count","ref":"GoogleApi.ServiceUsage.V1.Model.Billing.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Billing","doc":"*   `consumerDestinations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.BillingDestination.t)`, *default:* `nil`) - Billing configurations for sending metrics to the consumer project. There can be multiple consumer destinations per service, each one must have a different monitored resource type. A metric can be used in at most one consumer destination.","ref":"GoogleApi.ServiceUsage.V1.Model.Billing.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Billing.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Billing.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Billing.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Billing.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.BillingDestination","doc":"Configuration of a specific billing destination (Currently only support bill against consumer project).","ref":"GoogleApi.ServiceUsage.V1.Model.BillingDestination.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.BillingDestination","doc":"*   `metrics` (*type:* `list(String.t)`, *default:* `nil`) - Names of the metrics to report to this billing destination. Each name must be defined in Service.metrics section.\n*   `monitoredResource` (*type:* `String.t`, *default:* `nil`) - The monitored resource type. The type must be defined in Service.monitored_resources section.","ref":"GoogleApi.ServiceUsage.V1.Model.BillingDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.BillingDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.BillingDestination.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.BillingDestination.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.BillingDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest","doc":"The request message for Operations.CancelOperation.","ref":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CancelOperationRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings","doc":"Details about how and where to publish client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings","doc":"*   `cppSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.CppSettings.t`, *default:* `nil`) - Settings for C++ client libraries.\n*   `dotnetSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.DotnetSettings.t`, *default:* `nil`) - Settings for .NET client libraries.\n*   `goSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.GoSettings.t`, *default:* `nil`) - Settings for Go client libraries.\n*   `javaSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.JavaSettings.t`, *default:* `nil`) - Settings for legacy Java features, supported in the Service YAML.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Launch stage of this version of the API.\n*   `nodeSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.NodeSettings.t`, *default:* `nil`) - Settings for Node client libraries.\n*   `phpSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.PhpSettings.t`, *default:* `nil`) - Settings for PHP client libraries.\n*   `pythonSettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.PythonSettings.t`, *default:* `nil`) - Settings for Python client libraries.\n*   `restNumericEnums` (*type:* `boolean()`, *default:* `nil`) - When using transport=rest, the client request will encode enums as numbers rather than strings.\n*   `rubySettings` (*type:* `GoogleApi.ServiceUsage.V1.Model.RubySettings.t`, *default:* `nil`) - Settings for Ruby client libraries.\n*   `version` (*type:* `String.t`, *default:* `nil`) - Version of the API to apply these settings to. This is the full protobuf package for the API, ending in the version element. Examples: \"google.cloud.speech.v1\" and \"google.spanner.admin.database.v1\".","ref":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings","doc":"Required information for every language.","ref":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings","doc":"*   `destinations` (*type:* `list(String.t)`, *default:* `nil`) - The destination where API teams want this client library to be published.\n*   `referenceDocsUri` (*type:* `String.t`, *default:* `nil`) - Link to automatically generated reference documentation. Example: https://cloud.google.com/nodejs/docs/reference/asset/latest","ref":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy","doc":"Consumer Policy is a set of rules that define what services or service groups can be used for a cloud resource hierarchy.","ref":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy","doc":"*   `annotations` (*type:* `map()`, *default:* `nil`) - Optional. Annotations is an unstructured key-value map stored with a policy that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. [AIP-128](https://google.aip.dev/128#annotations)\n*   `enableRules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.EnableRule.t)`, *default:* `nil`) - Enable rules define usable services and service groups.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - An opaque tag indicating the current version of the policy, used for concurrency control.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The resource name of the policy. We only allow consumer policy name as `default` for now: `projects/12345/consumerPolicies/default`, `folders/12345/consumerPolicies/default`, `organizations/12345/consumerPolicies/default`.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - The last-modified time.","ref":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ConsumerPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Context","doc":"`Context` defines which contexts an API requests. Example: context: rules: - selector: \"*\" requested: - google.rpc.context.ProjectContext - google.rpc.context.OriginContext The above specifies that all methods in the API request `google.rpc.context.ProjectContext` and `google.rpc.context.OriginContext`. Available context types are defined in package `google.rpc.context`. This also provides mechanism to allowlist any protobuf message extension that can be sent in grpc metadata using “x-goog-ext--bin” and “x-goog-ext--jspb” format. For example, list any service specific protobuf types that can appear in grpc metadata as follows in your yaml file: Example: context: rules: - selector: \"google.example.library.v1.LibraryService.CreateBook\" allowed_request_extensions: - google.foo.v1.NewExtension allowed_response_extensions: - google.foo.v1.NewExtension You can also specify extension ID instead of fully qualified extension name here.","ref":"GoogleApi.ServiceUsage.V1.Model.Context.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Context","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.ContextRule.t)`, *default:* `nil`) - A list of RPC context rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceUsage.V1.Model.Context.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Context.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Context.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Context.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Context.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ContextRule","doc":"A context rule provides information about the context for an individual API element.","ref":"GoogleApi.ServiceUsage.V1.Model.ContextRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ContextRule","doc":"*   `allowedRequestExtensions` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names or extension IDs of extensions allowed in grpc side channel from client to backend.\n*   `allowedResponseExtensions` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names or extension IDs of extensions allowed in grpc side channel from backend to client.\n*   `provided` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names of provided contexts. It is used to support propagating HTTP headers and ETags from the response extension.\n*   `requested` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names of requested contexts, only the requested context will be made available to the backend.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.ContextRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ContextRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ContextRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ContextRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ContextRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Control","doc":"Selects and configures the service controller used by the service. Example: control: environment: servicecontrol.googleapis.com","ref":"GoogleApi.ServiceUsage.V1.Model.Control.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Control","doc":"*   `environment` (*type:* `String.t`, *default:* `nil`) - The service controller environment to use. If empty, no control plane feature (like quota and billing) will be enabled. The recommended value for most services is servicecontrol.googleapis.com\n*   `methodPolicies` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MethodPolicy.t)`, *default:* `nil`) - Defines policies applying to the API methods of the service.","ref":"GoogleApi.ServiceUsage.V1.Model.Control.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Control.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Control.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Control.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Control.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CppSettings","doc":"Settings for C++ client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.CppSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CppSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceUsage.V1.Model.CppSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CppSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CppSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CppSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CppSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata","doc":"Metadata message that provides information such as progress, partial failures, and similar information on each GetOperation call of LRO returned by CreateAdminQuotaPolicy.","ref":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CreateAdminQuotaPolicyMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CustomError","doc":"Customize service error responses. For example, list any service specific protobuf types that can appear in error detail lists of error responses. Example: custom_error: types: - google.foo.v1.CustomError - google.foo.v1.AnotherError","ref":"GoogleApi.ServiceUsage.V1.Model.CustomError.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CustomError","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.t)`, *default:* `nil`) - The list of custom error rules that apply to individual API messages. **NOTE:** All service configuration rules follow \"last one wins\" order.\n*   `types` (*type:* `list(String.t)`, *default:* `nil`) - The list of custom error detail types, e.g. 'google.foo.v1.CustomError'.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomError.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CustomError.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomError.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CustomError.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CustomError.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule","doc":"A custom error rule.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CustomErrorRule","doc":"*   `isErrorType` (*type:* `boolean()`, *default:* `nil`) - Mark this message as possible payload in error response. Otherwise, objects of this type will be filtered when they appear in error payload.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects messages to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CustomErrorRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern","doc":"A custom pattern is used for defining custom HTTP verb.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern","doc":"*   `kind` (*type:* `String.t`, *default:* `nil`) - The name of this custom HTTP verb.\n*   `path` (*type:* `String.t`, *default:* `nil`) - The path matched by this custom verb.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata","doc":"Metadata message that provides information such as progress, partial failures, and similar information on each GetOperation call of LRO returned by DeleteAdminQuotaPolicy.","ref":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.DeleteAdminQuotaPolicyMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest","doc":"Request message for the `DisableService` method.","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest","doc":"*   `checkIfServiceHasUsage` (*type:* `String.t`, *default:* `nil`) - Defines the behavior for checking service usage when disabling a service.\n*   `disableDependentServices` (*type:* `boolean()`, *default:* `nil`) - Indicates if services that are enabled and which depend on this service should also be disabled. If not set, an error will be generated if any enabled services depend on the service to be disabled. When set, the service, and any enabled services that depend on it, will be disabled together.","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse","doc":"Response message for the `DisableService` method. This response message is assigned to the `response` field of the returned Operation when that operation is done.","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse","doc":"*   `service` (*type:* `GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.t`, *default:* `nil`) - The new state of the service after disabling.","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.DisableServiceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Documentation","doc":"`Documentation` provides the information for describing a service. Example: documentation: summary: > The Google Calendar API gives access to most calendar features. pages: - name: Overview content: (== include google/foo/overview.md ==) - name: Tutorial content: (== include google/foo/tutorial.md ==) subpages: - name: Java content: (== include google/foo/tutorial_java.md ==) rules: - selector: google.calendar.Calendar.Get description: > ... - selector: google.calendar.Calendar.Put description: > ... Documentation is provided in markdown syntax. In addition to standard markdown features, definition lists, tables and fenced code blocks are supported. Section headers can be provided and are interpreted relative to the section nesting of the context where a documentation fragment is embedded. Documentation from the IDL is merged with documentation defined via the config at normalization time, where documentation provided by config rules overrides IDL provided. A number of constructs specific to the API platform are supported in documentation text. In order to reference a proto element, the following notation can be used: [fully.qualified.proto.name][] To override the display text used for the link, this can be used: [display text][fully.qualified.proto.name] Text can be excluded from doc using the following notation: (-- internal comment --) A few directives are available in documentation. Note that directives must appear on a single line to be properly identified. The `include` directive includes a markdown file from an external source: (== include path/to/file ==) The `resource_for` directive marks a message to be the resource of a collection in REST view. If it is not specified, tools attempt to infer the resource from the operations in a collection: (== resource_for v1.shelves.books ==) The directive `suppress_warning` does not directly affect documentation and is documented together with service config validation.","ref":"GoogleApi.ServiceUsage.V1.Model.Documentation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Documentation","doc":"*   `documentationRootUrl` (*type:* `String.t`, *default:* `nil`) - The URL to the root of documentation.\n*   `overview` (*type:* `String.t`, *default:* `nil`) - Declares a single overview page. For example: documentation: summary: ... overview: (== include overview.md ==) This is a shortcut for the following declaration (using pages style): documentation: summary: ... pages: - name: Overview content: (== include overview.md ==) Note: you cannot specify both `overview` field and `pages` field.\n*   `pages` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Page.t)`, *default:* `nil`) - The top level pages for the documentation set.\n*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.DocumentationRule.t)`, *default:* `nil`) - A list of documentation rules that apply to individual API elements. **NOTE:** All service configuration rules follow \"last one wins\" order.\n*   `sectionOverrides` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Page.t)`, *default:* `nil`) - Specifies section and content to override boilerplate content provided by go/api-docgen. Currently overrides following sections: 1. rest.service.client_libraries\n*   `serviceRootUrl` (*type:* `String.t`, *default:* `nil`) - Specifies the service root url if the default one (the service name from the yaml file) is not suitable. This can be seen in any fully specified service urls as well as sections that show a base that other urls are relative to.\n*   `summary` (*type:* `String.t`, *default:* `nil`) - A short description of what the service does. The summary must be plain text. It becomes the overview of the service displayed in Google Cloud Console. NOTE: This field is equivalent to the standard field `description`.","ref":"GoogleApi.ServiceUsage.V1.Model.Documentation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Documentation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Documentation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Documentation.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Documentation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule","doc":"A documentation rule provides information about individual API elements.","ref":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.DocumentationRule","doc":"*   `deprecationDescription` (*type:* `String.t`, *default:* `nil`) - Deprecation description of the selected element(s). It can be provided if an element is marked as `deprecated`.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Description of the selected proto element (e.g. a message, a method, a 'service' definition, or a field). Defaults to leading & trailing comments taken from the proto source definition of the proto element.\n*   `disableReplacementWords` (*type:* `String.t`, *default:* `nil`) - String of comma or space separated case-sensitive words for which method/field name replacement will be disabled by go/api-docgen.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - The selector is a comma-separated list of patterns for any element such as a method, a field, an enum value. Each pattern is a qualified name of the element which may end in \"*\", indicating a wildcard. Wildcards are only allowed at the end and for a whole component of the qualified name, i.e. \"foo.*\" is ok, but not \"foo.b*\" or \"foo.*.bar\". A wildcard will match one or more components. To specify a default for all applicable elements, the whole pattern \"*\" is used.","ref":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.DocumentationRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings","doc":"Settings for Dotnet client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.DotnetSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.\n*   `forcedNamespaceAliases` (*type:* `list(String.t)`, *default:* `nil`) - Namespaces which must be aliased in snippets due to a known (but non-generator-predictable) naming collision\n*   `handwrittenSignatures` (*type:* `list(String.t)`, *default:* `nil`) - Method signatures (in the form \"service.method(signature)\") which are provided separately, so shouldn't be generated. Snippets *calling* these methods are still generated, however.\n*   `ignoredResources` (*type:* `list(String.t)`, *default:* `nil`) - List of full resource types to ignore during generation. This is typically used for API-specific Location resources, which should be handled by the generator as if they were actually the common Location resources. Example entry: \"documentai.googleapis.com/Location\"\n*   `renamedResources` (*type:* `map()`, *default:* `nil`) - Map from full resource types to the effective short name for the resource. This is used when otherwise resource named from different services would cause naming collisions. Example entry: \"datalabeling.googleapis.com/Dataset\": \"DataLabelingDataset\"\n*   `renamedServices` (*type:* `map()`, *default:* `nil`) - Map from original service names to renamed versions. This is used when the default generated types would cause a naming conflict. (Neither name is fully-qualified.) Example: Subscriber to SubscriberServiceApi.","ref":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.DotnetSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.ServiceUsage.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Empty","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.EnableFailure","doc":"Provides error messages for the failing services.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableFailure.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.EnableFailure","doc":"*   `errorMessage` (*type:* `String.t`, *default:* `nil`) - An error message describing why the service could not be enabled.\n*   `serviceId` (*type:* `String.t`, *default:* `nil`) - The service id of a service that could not be enabled.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableFailure.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.EnableFailure.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableFailure.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.EnableFailure.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.EnableFailure.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.EnableRule","doc":"The consumer policy rule that defines usable services and service groups.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.EnableRule","doc":"*   `enableType` (*type:* `String.t`, *default:* `nil`) - Client and resource project enable type.\n*   `groups` (*type:* `list(String.t)`, *default:* `nil`) - DEPRECATED: Please use field `values`. Service group should have prefix `groups/`. The names of the service groups that are enabled (Not Implemented). Example: `groups/googleServices`.\n*   `services` (*type:* `list(String.t)`, *default:* `nil`) - DEPRECATED: Please use field `values`. Service should have prefix `services/`. The names of the services that are enabled. Example: `storage.googleapis.com`.\n*   `values` (*type:* `list(String.t)`, *default:* `nil`) - The names of the services or service groups that are enabled. Example: `services/storage.googleapis.com`, `groups/googleServices`, `groups/allServices`.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.EnableRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.EnableRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.EnableRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest","doc":"Request message for the `EnableService` method.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse","doc":"Response message for the `EnableService` method. This response message is assigned to the `response` field of the returned Operation when that operation is done.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse","doc":"*   `service` (*type:* `GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.t`, *default:* `nil`) - The new state of the service after enabling.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.EnableServiceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Endpoint","doc":"`Endpoint` describes a network address of a service that serves a set of APIs. It is commonly known as a service endpoint. A service may expose any number of service endpoints, and all service endpoints share the same service definition, such as quota limits and monitoring metrics. Example: type: google.api.Service name: library-example.googleapis.com endpoints: # Declares network address `https://library-example.googleapis.com` # for service `library-example.googleapis.com`. The `https` scheme # is implicit for all service endpoints. Other schemes may be # supported in the future. - name: library-example.googleapis.com allow_cors: false - name: content-staging-library-example.googleapis.com # Allows HTTP OPTIONS calls to be passed to the API frontend, for it # to decide whether the subsequent cross-origin request is allowed # to proceed. allow_cors: true","ref":"GoogleApi.ServiceUsage.V1.Model.Endpoint.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Endpoint","doc":"*   `aliases` (*type:* `list(String.t)`, *default:* `nil`) - Aliases for this endpoint, these will be served by the same UrlMap as the parent endpoint, and will be provisioned in the GCP stack for the Regional Endpoints.\n*   `allowCors` (*type:* `boolean()`, *default:* `nil`) - Allowing [CORS](https://en.wikipedia.org/wiki/Cross-origin_resource_sharing), aka cross-domain traffic, would allow the backends served from this endpoint to receive and respond to HTTP OPTIONS requests. The response will be used by the browser to determine whether the subsequent cross-origin request is allowed to proceed.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The canonical name of this endpoint.\n*   `target` (*type:* `String.t`, *default:* `nil`) - The specification of an Internet routable address of API frontend that will handle requests to this [API Endpoint](https://cloud.google.com/apis/design/glossary). It should be either a valid IPv4 address or a fully-qualified domain name. For example, \"8.8.8.8\" or \"myservice.appspot.com\".","ref":"GoogleApi.ServiceUsage.V1.Model.Endpoint.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Endpoint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Endpoint.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Endpoint.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Endpoint.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Enum","doc":"Enum type definition.","ref":"GoogleApi.ServiceUsage.V1.Model.Enum.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Enum","doc":"*   `edition` (*type:* `String.t`, *default:* `nil`) - The source edition string, only valid when syntax is SYNTAX_EDITIONS.\n*   `enumvalue` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.EnumValue.t)`, *default:* `nil`) - Enum value definitions.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Enum type name.\n*   `options` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Option.t)`, *default:* `nil`) - Protocol buffer options.\n*   `sourceContext` (*type:* `GoogleApi.ServiceUsage.V1.Model.SourceContext.t`, *default:* `nil`) - The source context.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax.","ref":"GoogleApi.ServiceUsage.V1.Model.Enum.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Enum.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Enum.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Enum.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Enum.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.EnumValue","doc":"Enum value definition.","ref":"GoogleApi.ServiceUsage.V1.Model.EnumValue.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.EnumValue","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - Enum value name.\n*   `number` (*type:* `integer()`, *default:* `nil`) - Enum value number.\n*   `options` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Option.t)`, *default:* `nil`) - Protocol buffer options.","ref":"GoogleApi.ServiceUsage.V1.Model.EnumValue.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.EnumValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.EnumValue.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.EnumValue.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.EnumValue.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Field","doc":"A single field of a message type.","ref":"GoogleApi.ServiceUsage.V1.Model.Field.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Field","doc":"*   `cardinality` (*type:* `String.t`, *default:* `nil`) - The field cardinality.\n*   `defaultValue` (*type:* `String.t`, *default:* `nil`) - The string value of the default value of this field. Proto2 syntax only.\n*   `jsonName` (*type:* `String.t`, *default:* `nil`) - The field JSON name.\n*   `kind` (*type:* `String.t`, *default:* `nil`) - The field type.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The field name.\n*   `number` (*type:* `integer()`, *default:* `nil`) - The field number.\n*   `oneofIndex` (*type:* `integer()`, *default:* `nil`) - The index of the field type in `Type.oneofs`, for message or enumeration types. The first type has index 1; zero means the type is not in the list.\n*   `options` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Option.t)`, *default:* `nil`) - The protocol buffer options.\n*   `packed` (*type:* `boolean()`, *default:* `nil`) - Whether to use alternative packed wire representation.\n*   `typeUrl` (*type:* `String.t`, *default:* `nil`) - The field type URL, without the scheme, for message or enumeration types. Example: `\"type.googleapis.com/google.protobuf.Timestamp\"`.","ref":"GoogleApi.ServiceUsage.V1.Model.Field.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Field.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Field.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Field.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Field.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy","doc":"Google API Policy Annotation This message defines a simple API policy annotation that can be used to annotate API request and response message fields with applicable policies. One field may have multiple applicable policies that must all be satisfied before a request can be processed. This policy annotation is used to generate the overall policy that will be used for automatic runtime policy enforcement and documentation generation.","ref":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.FieldPolicy","doc":"*   `resourcePermission` (*type:* `String.t`, *default:* `nil`) - Specifies the required permission(s) for the resource referred to by the field. It requires the field contains a valid resource reference, and the request must pass the permission checks to proceed. For example, \"resourcemanager.projects.get\".\n*   `resourceType` (*type:* `String.t`, *default:* `nil`) - Specifies the resource type for the resource referred to by the field.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects one or more request or response message fields to apply this `FieldPolicy`. When a `FieldPolicy` is used in proto annotation, the selector must be left as empty. The service config generator will automatically fill the correct value. When a `FieldPolicy` is used in service config, the selector must be a comma-separated string with valid request or response field paths, such as \"foo.bar\" or \"foo.bar,foo.baz\".","ref":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.FieldPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata","doc":"Metadata for the `GetServiceIdentity` method.","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse","doc":"Response message for getting service identity.","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse","doc":"*   `identity` (*type:* `GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.t`, *default:* `nil`) - Service identity that service producer can use to access consumer resources. If exists is true, it contains email and unique_id. If exists is false, it contains pre-constructed email and empty unique_id.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Service identity state.","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GetServiceIdentityResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoSettings","doc":"Settings for Go client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.GoSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceUsage.V1.Model.GoSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService","doc":"`Service` is the root object of Google API service configuration (service config). It describes the basic information about a logical service, such as the service name and the user-facing title, and delegates other aspects to sub-sections. Each sub-section is either a proto message or a repeated proto message that configures a specific aspect, such as auth. For more information, see each proto message definition. Example: type: google.api.Service name: calendar.googleapis.com title: Google Calendar API apis: - name: google.calendar.v3.Calendar visibility: rules: - selector: \"google.calendar.v3.*\" restriction: PREVIEW backend: rules: - selector: \"google.calendar.v3.*\" address: calendar.example.com authentication: providers: - id: google_calendar_auth jwks_uri: https://www.googleapis.com/oauth2/v1/certs issuer: https://securetoken.google.com rules: - selector: \"*\" requirements: provider_id: google_calendar_auth","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiService","doc":"*   `apis` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Api.t)`, *default:* `nil`) - A list of API interfaces exported by this service. Only the `name` field of the google.protobuf.Api needs to be provided by the configuration author, as the remaining fields will be derived from the IDL during the normalization process. It is an error to specify an API interface here which cannot be resolved against the associated IDL files.\n*   `authentication` (*type:* `GoogleApi.ServiceUsage.V1.Model.Authentication.t`, *default:* `nil`) - Auth configuration.\n*   `backend` (*type:* `GoogleApi.ServiceUsage.V1.Model.Backend.t`, *default:* `nil`) - API backend configuration.\n*   `billing` (*type:* `GoogleApi.ServiceUsage.V1.Model.Billing.t`, *default:* `nil`) - Billing configuration.\n*   `configVersion` (*type:* `integer()`, *default:* `nil`) - Obsolete. Do not use. This field has no semantic meaning. The service config compiler always sets this field to `3`.\n*   `context` (*type:* `GoogleApi.ServiceUsage.V1.Model.Context.t`, *default:* `nil`) - Context configuration.\n*   `control` (*type:* `GoogleApi.ServiceUsage.V1.Model.Control.t`, *default:* `nil`) - Configuration for the service control plane.\n*   `customError` (*type:* `GoogleApi.ServiceUsage.V1.Model.CustomError.t`, *default:* `nil`) - Custom error configuration.\n*   `documentation` (*type:* `GoogleApi.ServiceUsage.V1.Model.Documentation.t`, *default:* `nil`) - Additional API documentation.\n*   `endpoints` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Endpoint.t)`, *default:* `nil`) - Configuration for network endpoints. If this is empty, then an endpoint with the same name as the service is automatically generated to service all defined APIs.\n*   `enums` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Enum.t)`, *default:* `nil`) - A list of all enum types included in this API service. Enums referenced directly or indirectly by the `apis` are automatically included. Enums which are not referenced but shall be included should be listed here by name by the configuration author. Example: enums: - name: google.someapi.v1.SomeEnum\n*   `http` (*type:* `GoogleApi.ServiceUsage.V1.Model.Http.t`, *default:* `nil`) - HTTP configuration.\n*   `id` (*type:* `String.t`, *default:* `nil`) - A unique ID for a specific instance of this message, typically assigned by the client for tracking purpose. Must be no longer than 63 characters and only lower case letters, digits, '.', '_' and '-' are allowed. If empty, the server may choose to generate one instead.\n*   `logging` (*type:* `GoogleApi.ServiceUsage.V1.Model.Logging.t`, *default:* `nil`) - Logging configuration.\n*   `logs` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.LogDescriptor.t)`, *default:* `nil`) - Defines the logs used by this service.\n*   `metrics` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.t)`, *default:* `nil`) - Defines the metrics used by this service.\n*   `monitoredResources` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.t)`, *default:* `nil`) - Defines the monitored resources used by this service. This is required by the Service.monitoring and Service.logging configurations.\n*   `monitoring` (*type:* `GoogleApi.ServiceUsage.V1.Model.Monitoring.t`, *default:* `nil`) - Monitoring configuration.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The service name, which is a DNS-like logical identifier for the service, such as `calendar.googleapis.com`. The service name typically goes through DNS verification to make sure the owner of the service also owns the DNS name.\n*   `producerProjectId` (*type:* `String.t`, *default:* `nil`) - The Google project that owns this service.\n*   `publishing` (*type:* `GoogleApi.ServiceUsage.V1.Model.Publishing.t`, *default:* `nil`) - Settings for [Google Cloud Client libraries](https://cloud.google.com/apis/docs/cloud-client-libraries) generated from APIs defined as protocol buffers.\n*   `quota` (*type:* `GoogleApi.ServiceUsage.V1.Model.Quota.t`, *default:* `nil`) - Quota configuration.\n*   `sourceInfo` (*type:* `GoogleApi.ServiceUsage.V1.Model.SourceInfo.t`, *default:* `nil`) - Output only. The source information for this configuration if available.\n*   `systemParameters` (*type:* `GoogleApi.ServiceUsage.V1.Model.SystemParameters.t`, *default:* `nil`) - System parameter configuration.\n*   `systemTypes` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Type.t)`, *default:* `nil`) - A list of all proto message types included in this API service. It serves similar purpose as [google.api.Service.types], except that these types are not needed by user-defined APIs. Therefore, they will not show up in the generated discovery doc. This field should only be used to define system APIs in ESF.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The product title for this service, it is the name displayed in Google Cloud Console.\n*   `types` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Type.t)`, *default:* `nil`) - A list of all proto message types included in this API service. Types referenced directly or indirectly by the `apis` are automatically included. Messages which are not referenced but shall be included, such as types used by the `google.protobuf.Any` type, should be listed here by name by the configuration author. Example: types: - name: google.protobuf.Int32\n*   `usage` (*type:* `GoogleApi.ServiceUsage.V1.Model.Usage.t`, *default:* `nil`) - Configuration controlling usage of this service.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiService.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata","doc":"The operation metadata returned for the batchend services operation.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata","doc":"*   `resourceNames` (*type:* `list(String.t)`, *default:* `nil`) - The full name of the resources that this operation is directly associated with.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1OperationMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service","doc":"A service that is available for use by the consumer.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service","doc":"*   `config` (*type:* `GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.t`, *default:* `nil`) - The service configuration of the available service. Some fields may be filtered out of the configuration in responses to the `ListServices` method. These fields are present only in responses to the `GetService` method.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the consumer and service. A valid name would be: - projects/123/services/serviceusage.googleapis.com\n*   `parent` (*type:* `String.t`, *default:* `nil`) - The resource name of the consumer. A valid name would be: - projects/123\n*   `state` (*type:* `String.t`, *default:* `nil`) - Whether or not the service has been enabled for use by the consumer.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig","doc":"The configuration of the service.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig","doc":"*   `apis` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Api.t)`, *default:* `nil`) - A list of API interfaces exported by this service. Contains only the names, versions, and method names of the interfaces.\n*   `authentication` (*type:* `GoogleApi.ServiceUsage.V1.Model.Authentication.t`, *default:* `nil`) - Auth configuration. Contains only the OAuth rules.\n*   `documentation` (*type:* `GoogleApi.ServiceUsage.V1.Model.Documentation.t`, *default:* `nil`) - Additional API documentation. Contains only the summary and the documentation URL.\n*   `endpoints` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Endpoint.t)`, *default:* `nil`) - Configuration for network endpoints. Contains only the names and aliases of the endpoints.\n*   `monitoredResources` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.t)`, *default:* `nil`) - Defines the monitored resources used by this service. This is required by the Service.monitoring and Service.logging configurations.\n*   `monitoring` (*type:* `GoogleApi.ServiceUsage.V1.Model.Monitoring.t`, *default:* `nil`) - Monitoring configuration. This should not include the 'producer_destinations' field.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The DNS address at which this service is available. An example DNS address would be: `calendar.googleapis.com`.\n*   `quota` (*type:* `GoogleApi.ServiceUsage.V1.Model.Quota.t`, *default:* `nil`) - Quota configuration.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The product title for this service.\n*   `usage` (*type:* `GoogleApi.ServiceUsage.V1.Model.Usage.t`, *default:* `nil`) - Configuration controlling usage of this service.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1ServiceConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse","doc":"Response message for getting service identity.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse","doc":"*   `identity` (*type:* `GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.t`, *default:* `nil`) - Service identity that service producer can use to access consumer resources. If exists is true, it contains email and unique_id. If exists is false, it contains pre-constructed email and empty unique_id.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Service identity state.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1GetServiceIdentityResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity","doc":"Service identity for a service. This is the identity that service producer should use to access consumer resources.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity","doc":"*   `email` (*type:* `String.t`, *default:* `nil`) - The email address of the service account that a service producer would use to access consumer resources.\n*   `uniqueId` (*type:* `String.t`, *default:* `nil`) - The unique and stable id of the service account. https://cloud.google.com/iam/reference/rest/v1/projects.serviceAccounts#ServiceAccount","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1beta1ServiceIdentity.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy","doc":"Consumer Policy is a set of rules that define what services or service groups can be used for a cloud resource hierarchy.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy","doc":"*   `annotations` (*type:* `map()`, *default:* `nil`) - Optional. Annotations is an unstructured key-value map stored with a policy that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. [AIP-128](https://google.aip.dev/128#annotations)\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time the policy was created. For singleton policies, this is the first touch of the policy.\n*   `enableRules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.t)`, *default:* `nil`) - Enable rules define usable services, groups, and categories. There can currently be at most one `EnableRule`. This restriction will be lifted in later releases.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - Output only. An opaque tag indicating the current version of the policy, used for concurrency control.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The resource name of the policy. Only the `default` policy is supported: `projects/12345/consumerPolicies/default`, `folders/12345/consumerPolicies/default`, `organizations/12345/consumerPolicies/default`.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time the policy was last updated.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaConsumerPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule","doc":"The consumer policy rule that defines enabled services, groups, and categories.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule","doc":"*   `services` (*type:* `list(String.t)`, *default:* `nil`) - The names of the services that are enabled. Example: `services/storage.googleapis.com`.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaEnableRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata","doc":"Metadata for the `UpdateConsumerPolicy` method.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV2alphaUpdateConsumerPolicyMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Http","doc":"Defines the HTTP configuration for an API service. It contains a list of HttpRule, each specifying the mapping of an RPC method to one or more HTTP REST API methods.","ref":"GoogleApi.ServiceUsage.V1.Model.Http.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Http","doc":"*   `fullyDecodeReservedExpansion` (*type:* `boolean()`, *default:* `nil`) - When set to true, URL path parameters will be fully URI-decoded except in cases of single segment matches in reserved expansion, where \"%2F\" will be left encoded. The default behavior is to not decode RFC 6570 reserved characters in multi segment matches.\n*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.HttpRule.t)`, *default:* `nil`) - A list of HTTP configuration rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceUsage.V1.Model.Http.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Http.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Http.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Http.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Http.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.HttpRule","doc":"gRPC Transcoding gRPC Transcoding is a feature for mapping between a gRPC method and one or more HTTP REST endpoints. It allows developers to build a single API service that supports both gRPC APIs and REST APIs. Many systems, including [Google APIs](https://github.com/googleapis/googleapis), [Cloud Endpoints](https://cloud.google.com/endpoints), [gRPC Gateway](https://github.com/grpc-ecosystem/grpc-gateway), and [Envoy](https://github.com/envoyproxy/envoy) proxy support this feature and use it for large scale production services. `HttpRule` defines the schema of the gRPC/REST mapping. The mapping specifies how different portions of the gRPC request message are mapped to the URL path, URL query parameters, and HTTP request body. It also controls how the gRPC response message is mapped to the HTTP response body. `HttpRule` is typically specified as an `google.api.http` annotation on the gRPC method. Each mapping specifies a URL path template and an HTTP method. The path template may refer to one or more fields in the gRPC request message, as long as each field is a non-repeated field with a primitive (non-message) type. The path template controls how fields of the request message are mapped to the URL path. Example: service Messaging { rpc GetMessage(GetMessageRequest) returns (Message) { option (google.api.http) = { get: \"/v1/{name=messages/*}\" }; } } message GetMessageRequest { string name = 1; // Mapped to URL path. } message Message { string text = 1; // The resource content. } This enables an HTTP REST to gRPC mapping as below: - HTTP: `GET /v1/messages/123456` - gRPC: `GetMessage(name: \"messages/123456\")` Any fields in the request message which are not bound by the path template automatically become HTTP query parameters if there is no HTTP request body. For example: service Messaging { rpc GetMessage(GetMessageRequest) returns (Message) { option (google.api.http) = { get:\"/v1/messages/{message_id}\" }; } } message GetMessageRequest { message SubMessage { string subfield = 1; } string message_id = 1; // Mapped to URL path. int64 revision = 2; // Mapped to URL query parameter `revision`. SubMessage sub = 3; // Mapped to URL query parameter `sub.subfield`. } This enables a HTTP JSON to RPC mapping as below: - HTTP: `GET /v1/messages/123456?revision=2&sub.subfield=foo` - gRPC: `GetMessage(message_id: \"123456\" revision: 2 sub: SubMessage(subfield: \"foo\"))` Note that fields which are mapped to URL query parameters must have a primitive type or a repeated primitive type or a non-repeated message type. In the case of a repeated type, the parameter can be repeated in the URL as `...?param=A&param=B`. In the case of a message type, each field of the message is mapped to a separate parameter, such as `...?foo.a=A&foo.b=B&foo.c=C`. For HTTP methods that allow a request body, the `body` field specifies the mapping. Consider a REST update method on the message resource collection: service Messaging { rpc UpdateMessage(UpdateMessageRequest) returns (Message) { option (google.api.http) = { patch: \"/v1/messages/{message_id}\" body: \"message\" }; } } message UpdateMessageRequest { string message_id = 1; // mapped to the URL Message message = 2; // mapped to the body } The following HTTP JSON to RPC mapping is enabled, where the representation of the JSON in the request body is determined by protos JSON encoding: - HTTP: `PATCH /v1/messages/123456 { \"text\": \"Hi!\" }` - gRPC: `UpdateMessage(message_id: \"123456\" message { text: \"Hi!\" })` The special name `*` can be used in the body mapping to define that every field not bound by the path template should be mapped to the request body. This enables the following alternative definition of the update method: service Messaging { rpc UpdateMessage(Message) returns (Message) { option (google.api.http) = { patch: \"/v1/messages/{message_id}\" body: \"*\" }; } } message Message { string message_id = 1; string text = 2; } The following HTTP JSON to RPC mapping is enabled: - HTTP: `PATCH /v1/messages/123456 { \"text\": \"Hi!\" }` - gRPC: `UpdateMessage(message_id: \"123456\" text: \"Hi!\")` Note that when using `*` in the body mapping, it is not possible to have HTTP parameters, as all fields not bound by the path end in the body. This makes this option more rarely used in practice when defining REST APIs. The common usage of `*` is in custom methods which don't use the URL at all for transferring data. It is possible to define multiple HTTP methods for one RPC by using the `additional_bindings` option. Example: service Messaging { rpc GetMessage(GetMessageRequest) returns (Message) { option (google.api.http) = { get: \"/v1/messages/{message_id}\" additional_bindings { get: \"/v1/users/{user_id}/messages/{message_id}\" } }; } } message GetMessageRequest { string message_id = 1; string user_id = 2; } This enables the following two alternative HTTP JSON to RPC mappings: - HTTP: `GET /v1/messages/123456` - gRPC: `GetMessage(message_id: \"123456\")` - HTTP: `GET /v1/users/me/messages/123456` - gRPC: `GetMessage(user_id: \"me\" message_id: \"123456\")` Rules for HTTP mapping 1. Leaf request fields (recursive expansion nested messages in the request message) are classified into three categories: - Fields referred by the path template. They are passed via the URL path. - Fields referred by the HttpRule.body. They are passed via the HTTP request body. - All other fields are passed via the URL query parameters, and the parameter name is the field path in the request message. A repeated field can be represented as multiple query parameters under the same name. 2. If HttpRule.body is \"*\", there is no URL query parameter, all fields are passed via URL path and HTTP request body. 3. If HttpRule.body is omitted, there is no HTTP request body, all fields are passed via URL path and URL query parameters. Path template syntax Template = \"/\" Segments [ Verb ] ; Segments = Segment { \"/\" Segment } ; Segment = \"*\" | \"**\" | LITERAL | Variable ; Variable = \"{\" FieldPath [ \"=\" Segments ] \"}\" ; FieldPath = IDENT { \".\" IDENT } ; Verb = \":\" LITERAL ; The syntax `*` matches a single URL path segment. The syntax `**` matches zero or more URL path segments, which must be the last part of the URL path except the `Verb`. The syntax `Variable` matches part of the URL path as specified by its template. A variable template must not contain other variables. If a variable matches a single path segment, its template may be omitted, e.g. `{var}` is equivalent to `{var=*}`. The syntax `LITERAL` matches literal text in the URL path. If the `LITERAL` contains any reserved character, such characters should be percent-encoded before the matching. If a variable contains exactly one path segment, such as `\"{var}\"` or `\"{var=*}\"`, when such a variable is expanded into a URL path on the client side, all characters except `[-_.~0-9a-zA-Z]` are percent-encoded. The server side does the reverse decoding. Such variables show up in the [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) as `{var}`. If a variable contains multiple path segments, such as `\"{var=foo/*}\"` or `\"{var=**}\"`, when such a variable is expanded into a URL path on the client side, all characters except `[-_.~/0-9a-zA-Z]` are percent-encoded. The server side does the reverse decoding, except \"%2F\" and \"%2f\" are left unchanged. Such variables show up in the [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) as `{+var}`. Using gRPC API Service Configuration gRPC API Service Configuration (service config) is a configuration language for configuring a gRPC service to become a user-facing product. The service config is simply the YAML representation of the `google.api.Service` proto message. As an alternative to annotating your proto file, you can configure gRPC transcoding in your service config YAML files. You do this by specifying a `HttpRule` that maps the gRPC method to a REST endpoint, achieving the same effect as the proto annotation. This can be particularly useful if you have a proto that is reused in multiple services. Note that any transcoding specified in the service config will override any matching transcoding configuration in the proto. The following example selects a gRPC method and applies an `HttpRule` to it: http: rules: - selector: example.v1.Messaging.GetMessage get: /v1/messages/{message_id}/{sub.subfield} Special notes When gRPC Transcoding is used to map a gRPC to JSON REST endpoints, the proto to JSON conversion must follow the [proto3 specification](https://developers.google.com/protocol-buffers/docs/proto3#json). While the single segment variable follows the semantics of [RFC 6570](https://tools.ietf.org/html/rfc6570) Section 3.2.2 Simple String Expansion, the multi segment variable **does not** follow RFC 6570 Section 3.2.3 Reserved Expansion. The reason is that the Reserved Expansion does not expand special characters like `?` and `#`, which would lead to invalid URLs. As the result, gRPC Transcoding uses a custom encoding for multi segment variables. The path variables **must not** refer to any repeated or mapped field, because client libraries are not capable of handling such variable expansion. The path variables **must not** capture the leading \"/\" character. The reason is that the most common use case \"{var}\" does not capture the leading \"/\" character. For consistency, all path variables must share the same behavior. Repeated message fields must not be mapped to URL query parameters, because no client library can support such complicated mapping. If an API needs to use a JSON array for request or response body, it can map the request or response body to a repeated field. However, some gRPC Transcoding implementations may not support this feature.","ref":"GoogleApi.ServiceUsage.V1.Model.HttpRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.HttpRule","doc":"*   `additionalBindings` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.HttpRule.t)`, *default:* `nil`) - Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).\n*   `body` (*type:* `String.t`, *default:* `nil`) - The name of the request field whose value is mapped to the HTTP request body, or `*` for mapping all request fields not captured by the path pattern to the HTTP body, or omitted for not having any HTTP request body. NOTE: the referred field must be present at the top-level of the request message type.\n*   `custom` (*type:* `GoogleApi.ServiceUsage.V1.Model.CustomHttpPattern.t`, *default:* `nil`) - The custom pattern is used for specifying an HTTP method that is not included in the `pattern` field, such as HEAD, or \"*\" to leave the HTTP method unspecified for this rule. The wild-card rule is useful for services that provide content to Web (HTML) clients.\n*   `delete` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP DELETE. Used for deleting a resource.\n*   `get` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP GET. Used for listing and getting information about resources.\n*   `patch` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP PATCH. Used for updating a resource.\n*   `post` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP POST. Used for creating a resource or performing an action.\n*   `put` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP PUT. Used for replacing a resource.\n*   `responseBody` (*type:* `String.t`, *default:* `nil`) - Optional. The name of the response field whose value is mapped to the HTTP response body. When omitted, the entire response message will be used as the HTTP response body. NOTE: The referred field must be present at the top-level of the response message type.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects a method to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.HttpRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.HttpRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.HttpRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.HttpRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.HttpRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata","doc":"Metadata message that provides information such as progress, partial failures, and similar information on each GetOperation call of LRO returned by ImportAdminOverrides.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse","doc":"Response message for ImportAdminOverrides","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse","doc":"*   `overrides` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.QuotaOverride.t)`, *default:* `nil`) - The overrides that were created from the imported data.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminOverridesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata","doc":"Metadata message that provides information such as progress, partial failures, and similar information on each GetOperation call of LRO returned by ImportAdminQuotaPolicies.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse","doc":"Response message for ImportAdminQuotaPolicies","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse","doc":"*   `policies` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.AdminQuotaPolicy.t)`, *default:* `nil`) - The policies that were created from the imported data.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportAdminQuotaPoliciesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata","doc":"Metadata message that provides information such as progress, partial failures, and similar information on each GetOperation call of LRO returned by ImportConsumerOverrides.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse","doc":"Response message for ImportConsumerOverrides","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse","doc":"*   `overrides` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.QuotaOverride.t)`, *default:* `nil`) - The overrides that were created from the imported data.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ImportConsumerOverridesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.JavaSettings","doc":"Settings for Java client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.JavaSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.JavaSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.\n*   `libraryPackage` (*type:* `String.t`, *default:* `nil`) - The package name to use in Java. Clobbers the java_package option set in the protobuf. This should be used **only** by APIs who have already set the language_settings.java.package_name\" field in gapic.yaml. API teams should use the protobuf java_package option where possible. Example of a YAML configuration:: publishing: java_settings: library_package: com.google.cloud.pubsub.v1\n*   `serviceClassNames` (*type:* `map()`, *default:* `nil`) - Configure the Java class name to use instead of the service's for its corresponding generated GAPIC client. Keys are fully-qualified service names as they appear in the protobuf (including the full the language_settings.java.interface_names\" field in gapic.yaml. API teams should otherwise use the service name as it appears in the protobuf. Example of a YAML configuration:: publishing: java_settings: service_class_names: - google.pubsub.v1.Publisher: TopicAdmin - google.pubsub.v1.Subscriber: SubscriptionAdmin","ref":"GoogleApi.ServiceUsage.V1.Model.JavaSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.JavaSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.JavaSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.JavaSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.JavaSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.JwtLocation","doc":"Specifies a location to extract JWT from an API request.","ref":"GoogleApi.ServiceUsage.V1.Model.JwtLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.JwtLocation","doc":"*   `cookie` (*type:* `String.t`, *default:* `nil`) - Specifies cookie name to extract JWT token.\n*   `header` (*type:* `String.t`, *default:* `nil`) - Specifies HTTP header name to extract JWT token.\n*   `query` (*type:* `String.t`, *default:* `nil`) - Specifies URL query parameter name to extract JWT token.\n*   `valuePrefix` (*type:* `String.t`, *default:* `nil`) - The value prefix. The value format is \"value_prefix{token}\" Only applies to \"in\" header type. Must be empty for \"in\" query type. If not empty, the header value has to match (case sensitive) this prefix. If not matched, JWT will not be extracted. If matched, JWT will be extracted after the prefix is removed. For example, for \"Authorization: Bearer {JWT}\", value_prefix=\"Bearer \" with a space at the end.","ref":"GoogleApi.ServiceUsage.V1.Model.JwtLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.JwtLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.JwtLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.JwtLocation.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.JwtLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor","doc":"A description of a label.","ref":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.LabelDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A human-readable description for the label.\n*   `key` (*type:* `String.t`, *default:* `nil`) - The label key.\n*   `valueType` (*type:* `String.t`, *default:* `nil`) - The type of data that can be assigned to the label.","ref":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse","doc":"The response message for Operations.ListOperations.","ref":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The standard List next-page token.\n*   `operations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Operation.t)`, *default:* `nil`) - A list of operations that matches the specified filter in the request.","ref":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ListOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse","doc":"Response message for the `ListServices` method.","ref":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ListServicesResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token that can be passed to `ListServices` to resume a paginated query.\n*   `services` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.GoogleApiServiceusageV1Service.t)`, *default:* `nil`) - The available services for the requested project.","ref":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ListServicesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor","doc":"A description of a log type. Example in YAML format: - name: library.googleapis.com/activity_history description: The history of borrowing and returning library items. display_name: Activity labels: - key: /customer_id description: Identifier of a library customer","ref":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.LogDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A human-readable description of this log. This information appears in the documentation and can contain details.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The human-readable name for this log. This information appears on the user interface and should be concise.\n*   `labels` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.t)`, *default:* `nil`) - The set of labels that are available to describe a specific log entry. Runtime requests that contain labels not specified here are considered invalid.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the log. It must be less than 512 characters long and can include the following characters: upper- and lower-case alphanumeric characters [A-Za-z0-9], and punctuation characters including slash, underscore, hyphen, period [/_-.].","ref":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.LogDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Logging","doc":"Logging configuration of the service. The following example shows how to configure logs to be sent to the producer and consumer projects. In the example, the `activity_history` log is sent to both the producer and consumer projects, whereas the `purchase_history` log is only sent to the producer project. monitored_resources: - type: library.googleapis.com/branch labels: - key: /city description: The city where the library branch is located in. - key: /name description: The name of the branch. logs: - name: activity_history labels: - key: /customer_id - name: purchase_history logging: producer_destinations: - monitored_resource: library.googleapis.com/branch logs: - activity_history - purchase_history consumer_destinations: - monitored_resource: library.googleapis.com/branch logs: - activity_history","ref":"GoogleApi.ServiceUsage.V1.Model.Logging.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Logging","doc":"*   `consumerDestinations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.LoggingDestination.t)`, *default:* `nil`) - Logging configurations for sending logs to the consumer project. There can be multiple consumer destinations, each one must have a different monitored resource type. A log can be used in at most one consumer destination.\n*   `producerDestinations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.LoggingDestination.t)`, *default:* `nil`) - Logging configurations for sending logs to the producer project. There can be multiple producer destinations, each one must have a different monitored resource type. A log can be used in at most one producer destination.","ref":"GoogleApi.ServiceUsage.V1.Model.Logging.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Logging.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Logging.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Logging.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Logging.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination","doc":"Configuration of a specific logging destination (the producer project or the consumer project).","ref":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.LoggingDestination","doc":"*   `logs` (*type:* `list(String.t)`, *default:* `nil`) - Names of the logs to be sent to this destination. Each name must be defined in the Service.logs section. If the log name is not a domain scoped name, it will be automatically prefixed with the service name followed by \"/\".\n*   `monitoredResource` (*type:* `String.t`, *default:* `nil`) - The monitored resource type. The type must be defined in the Service.monitored_resources section.","ref":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.LoggingDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.LongRunning","doc":"Describes settings to use when generating API methods that use the long-running operation pattern. All default values below are from those used in the client library generators (e.g. [Java](https://github.com/googleapis/gapic-generator-java/blob/04c2faa191a9b5a10b92392fe8482279c4404803/src/main/java/com/google/api/generator/gapic/composer/common/RetrySettingsComposer.java)).","ref":"GoogleApi.ServiceUsage.V1.Model.LongRunning.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.LongRunning","doc":"*   `initialPollDelay` (*type:* `String.t`, *default:* `nil`) - Initial delay after which the first poll request will be made. Default value: 5 seconds.\n*   `maxPollDelay` (*type:* `String.t`, *default:* `nil`) - Maximum time between two subsequent poll requests. Default value: 45 seconds.\n*   `pollDelayMultiplier` (*type:* `number()`, *default:* `nil`) - Multiplier to gradually increase delay between subsequent polls until it reaches max_poll_delay. Default value: 1.5.\n*   `totalPollTimeout` (*type:* `String.t`, *default:* `nil`) - Total polling timeout. Default value: 5 minutes.","ref":"GoogleApi.ServiceUsage.V1.Model.LongRunning.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.LongRunning.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.LongRunning.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.LongRunning.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.LongRunning.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Method","doc":"Method represents a method of an API interface.","ref":"GoogleApi.ServiceUsage.V1.Model.Method.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Method","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The simple name of this method.\n*   `options` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Option.t)`, *default:* `nil`) - Any metadata attached to the method.\n*   `requestStreaming` (*type:* `boolean()`, *default:* `nil`) - If true, the request is streamed.\n*   `requestTypeUrl` (*type:* `String.t`, *default:* `nil`) - A URL of the input message type.\n*   `responseStreaming` (*type:* `boolean()`, *default:* `nil`) - If true, the response is streamed.\n*   `responseTypeUrl` (*type:* `String.t`, *default:* `nil`) - The URL of the output message type.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax of this method.","ref":"GoogleApi.ServiceUsage.V1.Model.Method.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Method.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Method.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Method.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Method.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy","doc":"Defines policies applying to an RPC method.","ref":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MethodPolicy","doc":"*   `requestPolicies` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.FieldPolicy.t)`, *default:* `nil`) - Policies that are applicable to the request message.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects a method to which these policies should be enforced, for example, \"google.pubsub.v1.Subscriber.CreateSubscription\". Refer to selector for syntax details. NOTE: This field must not be set in the proto annotation. It will be automatically filled by the service config compiler .","ref":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MethodPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MethodSettings","doc":"Describes the generator configuration for a method.","ref":"GoogleApi.ServiceUsage.V1.Model.MethodSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MethodSettings","doc":"*   `autoPopulatedFields` (*type:* `list(String.t)`, *default:* `nil`) - List of top-level fields of the request message, that should be automatically populated by the client libraries based on their (google.api.field_info).format. Currently supported format: UUID4. Example of a YAML configuration: publishing: method_settings: - selector: google.example.v1.ExampleService.CreateExample auto_populated_fields: - request_id\n*   `longRunning` (*type:* `GoogleApi.ServiceUsage.V1.Model.LongRunning.t`, *default:* `nil`) - Describes settings to use for long-running operations when generating API methods for RPCs. Complements RPCs that use the annotations in google/longrunning/operations.proto. Example of a YAML configuration:: publishing: method_settings: - selector: google.cloud.speech.v2.Speech.BatchRecognize long_running: initial_poll_delay: 60s # 1 minute poll_delay_multiplier: 1.5 max_poll_delay: 360s # 6 minutes total_poll_timeout: 54000s # 90 minutes\n*   `selector` (*type:* `String.t`, *default:* `nil`) - The fully qualified name of the method, for which the options below apply. This is used to find the method to apply the options. Example: publishing: method_settings: - selector: google.storage.control.v2.StorageControl.CreateFolder # method settings for CreateFolder...","ref":"GoogleApi.ServiceUsage.V1.Model.MethodSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MethodSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MethodSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MethodSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MethodSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor","doc":"Defines a metric type and its schema. Once a metric descriptor is created, deleting or altering it stops data collection and makes the metric type's existing data unusable.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MetricDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A detailed description of the metric, which can be used in documentation.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - A concise name for the metric, which can be displayed in user interfaces. Use sentence case without an ending period, for example \"Request count\". This field is optional but it is recommended to be set for any metrics associated with user-visible concepts, such as Quota.\n*   `labels` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.t)`, *default:* `nil`) - The set of labels that can be used to describe a specific instance of this metric type. For example, the `appengine.googleapis.com/http/server/response_latencies` metric type has a label for the HTTP response code, `response_code`, so you can look at latencies for successful responses or just for responses that failed.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Optional. The launch stage of the metric definition.\n*   `metadata` (*type:* `GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.t`, *default:* `nil`) - Optional. Metadata which can be used to guide usage of the metric.\n*   `metricKind` (*type:* `String.t`, *default:* `nil`) - Whether the metric records instantaneous values, changes to a value, etc. Some combinations of `metric_kind` and `value_type` might not be supported.\n*   `monitoredResourceTypes` (*type:* `list(String.t)`, *default:* `nil`) - Read-only. If present, then a time series, which is identified partially by a metric type and a MonitoredResourceDescriptor, that is associated with this metric type can only be associated with one of the monitored resource types listed here.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the metric descriptor.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The metric type, including its DNS name prefix. The type is not URL-encoded. All user-defined metric types have the DNS name `custom.googleapis.com` or `external.googleapis.com`. Metric types should use a natural hierarchical grouping. For example: \"custom.googleapis.com/invoice/paid/amount\" \"external.googleapis.com/prometheus/up\" \"appengine.googleapis.com/http/server/response_latencies\"\n*   `unit` (*type:* `String.t`, *default:* `nil`) - The units in which the metric value is reported. It is only applicable if the `value_type` is `INT64`, `DOUBLE`, or `DISTRIBUTION`. The `unit` defines the representation of the stored metric values. Different systems might scale the values to be more easily displayed (so a value of `0.02kBy` _might_ be displayed as `20By`, and a value of `3523kBy` _might_ be displayed as `3.5MBy`). However, if the `unit` is `kBy`, then the value of the metric is always in thousands of bytes, no matter how it might be displayed. If you want a custom metric to record the exact number of CPU-seconds used by a job, you can create an `INT64 CUMULATIVE` metric whose `unit` is `s{CPU}` (or equivalently `1s{CPU}` or just `s`). If the job uses 12,005 CPU-seconds, then the value is written as `12005`. Alternatively, if you want a custom metric to record data in a more granular way, you can create a `DOUBLE CUMULATIVE` metric whose `unit` is `ks{CPU}`, and then write the value `12.005` (which is `12005/1000`), or use `Kis{CPU}` and write `11.723` (which is `12005/1024`). The supported units are a subset of [The Unified Code for Units of Measure](https://unitsofmeasure.org/ucum.html) standard: **Basic units (UNIT)** * `bit` bit * `By` byte * `s` second * `min` minute * `h` hour * `d` day * `1` dimensionless **Prefixes (PREFIX)** * `k` kilo (10^3) * `M` mega (10^6) * `G` giga (10^9) * `T` tera (10^12) * `P` peta (10^15) * `E` exa (10^18) * `Z` zetta (10^21) * `Y` yotta (10^24) * `m` milli (10^-3) * `u` micro (10^-6) * `n` nano (10^-9) * `p` pico (10^-12) * `f` femto (10^-15) * `a` atto (10^-18) * `z` zepto (10^-21) * `y` yocto (10^-24) * `Ki` kibi (2^10) * `Mi` mebi (2^20) * `Gi` gibi (2^30) * `Ti` tebi (2^40) * `Pi` pebi (2^50) **Grammar** The grammar also includes these connectors: * `/` division or ratio (as an infix operator). For examples, `kBy/{email}` or `MiBy/10ms` (although you should almost never have `/s` in a metric `unit`; rates should always be computed at query time from the underlying cumulative or delta value). * `.` multiplication or composition (as an infix operator). For examples, `GBy.d` or `k{watt}.h`. The grammar for a unit is as follows: Expression = Component { \".\" Component } { \"/\" Component } ; Component = ( [ PREFIX ] UNIT | \"%\" ) [ Annotation ] | Annotation | \"1\" ; Annotation = \"{\" NAME \"}\" ; Notes: * `Annotation` is just a comment if it follows a `UNIT`. If the annotation is used alone, then the unit is equivalent to `1`. For examples, `{request}/s == 1/s`, `By{transmitted}/s == By/s`. * `NAME` is a sequence of non-blank printable ASCII characters not containing `{` or `}`. * `1` represents a unitary [dimensionless unit](https://en.wikipedia.org/wiki/Dimensionless_quantity) of 1, such as in `1/s`. It is typically used when none of the basic units are appropriate. For example, \"new users per day\" can be represented as `1/d` or `{new-users}/d` (and a metric value `5` would mean \"5 new users). Alternatively, \"thousands of page views per day\" would be represented as `1000/d` or `k1/d` or `k{page_views}/d` (and a metric value of `5.3` would mean \"5300 page views per day\"). * `%` represents dimensionless value of 1/100, and annotates values giving a percentage (so the metric values are typically in the range of 0..100, and a metric value `3` means \"3 percent\"). * `10^2.%` indicates a metric contains a ratio, typically in the range 0..1, that will be multiplied by 100 and displayed as a percentage (so a metric value `0.03` means \"3 percent\").\n*   `valueType` (*type:* `String.t`, *default:* `nil`) - Whether the measurement is an integer, a floating-point number, etc. Some combinations of `metric_kind` and `value_type` might not be supported.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata","doc":"Additional annotations that can be used to guide the usage of a metric.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata","doc":"*   `ingestDelay` (*type:* `String.t`, *default:* `nil`) - The delay of data points caused by ingestion. Data points older than this age are guaranteed to be ingested and available to be read, excluding data loss due to errors.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Deprecated. Must use the MetricDescriptor.launch_stage instead.\n*   `samplePeriod` (*type:* `String.t`, *default:* `nil`) - The sampling period of metric data points. For metrics which are written periodically, consecutive data points are stored at this time interval, excluding data loss due to errors. Metrics with a higher granularity have a smaller sampling period.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MetricDescriptorMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MetricRule","doc":"Bind API methods to metrics. Binding a method to a metric causes that metric's configured quota behaviors to apply to the method call.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MetricRule","doc":"*   `metricCosts` (*type:* `map()`, *default:* `nil`) - Metrics to update when the selected methods are called, and the associated cost applied to each metric. The key of the map is the metric name, and the values are the amount increased for the metric against which the quota limits are defined. The value must not be negative.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MetricRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MetricRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MetricRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MetricRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Mixin","doc":"Declares an API Interface to be included in this interface. The including interface must redeclare all the methods from the included interface, but documentation and options are inherited as follows: - If after comment and whitespace stripping, the documentation string of the redeclared method is empty, it will be inherited from the original method. - Each annotation belonging to the service config (http, visibility) which is not set in the redeclared method will be inherited. - If an http annotation is inherited, the path pattern will be modified as follows. Any version prefix will be replaced by the version of the including interface plus the root path if specified. Example of a simple mixin: package google.acl.v1; service AccessControl { // Get the underlying ACL object. rpc GetAcl(GetAclRequest) returns (Acl) { option (google.api.http).get = \"/v1/{resource=**}:getAcl\"; } } package google.storage.v2; service Storage { // rpc GetAcl(GetAclRequest) returns (Acl); // Get a data record. rpc GetData(GetDataRequest) returns (Data) { option (google.api.http).get = \"/v2/{resource=**}\"; } } Example of a mixin configuration: apis: - name: google.storage.v2.Storage mixins: - name: google.acl.v1.AccessControl The mixin construct implies that all methods in `AccessControl` are also declared with same name and request/response types in `Storage`. A documentation generator or annotation processor will see the effective `Storage.GetAcl` method after inherting documentation and annotations as follows: service Storage { // Get the underlying ACL object. rpc GetAcl(GetAclRequest) returns (Acl) { option (google.api.http).get = \"/v2/{resource=**}:getAcl\"; } ... } Note how the version in the path pattern changed from `v1` to `v2`. If the `root` field in the mixin is specified, it should be a relative path under which inherited HTTP paths are placed. Example: apis: - name: google.storage.v2.Storage mixins: - name: google.acl.v1.AccessControl root: acls This implies the following inherited HTTP annotation: service Storage { // Get the underlying ACL object. rpc GetAcl(GetAclRequest) returns (Acl) { option (google.api.http).get = \"/v2/acls/{resource=**}:getAcl\"; } ... }","ref":"GoogleApi.ServiceUsage.V1.Model.Mixin.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Mixin","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The fully qualified name of the interface which is included.\n*   `root` (*type:* `String.t`, *default:* `nil`) - If non-empty specifies a path under which inherited HTTP paths are rooted.","ref":"GoogleApi.ServiceUsage.V1.Model.Mixin.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Mixin.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Mixin.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Mixin.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Mixin.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor","doc":"An object that describes the schema of a MonitoredResource object using a type name and a set of labels. For example, the monitored resource descriptor for Google Compute Engine VM instances has a type of `\"gce_instance\"` and specifies the use of the labels `\"instance_id\"` and `\"zone\"` to identify particular VM instances. Different APIs can support different monitored resource types. APIs generally provide a `list` method that returns the monitored resource descriptors used by the API.","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. A detailed description of the monitored resource type that might be used in documentation.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - Optional. A concise name for the monitored resource type that might be displayed in user interfaces. It should be a Title Cased Noun Phrase, without any article or other determiners. For example, `\"Google Cloud SQL Database\"`.\n*   `labels` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.LabelDescriptor.t)`, *default:* `nil`) - Required. A set of labels used to describe instances of this monitored resource type. For example, an individual Google Cloud SQL database is identified by values for the labels `\"database_id\"` and `\"zone\"`.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Optional. The launch stage of the monitored resource definition.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Optional. The resource name of the monitored resource descriptor: `\"projects/{project_id}/monitoredResourceDescriptors/{type}\"` where {type} is the value of the `type` field in this object and {project_id} is a project ID that provides API-specific context for accessing the type. APIs that do not use project information can use the resource name format `\"monitoredResourceDescriptors/{type}\"`.\n*   `type` (*type:* `String.t`, *default:* `nil`) - Required. The monitored resource type. For example, the type `\"cloudsql_database\"` represents databases in Google Cloud SQL. For a list of types, see [Monitored resource types](https://cloud.google.com/monitoring/api/resources) and [Logging resource types](https://cloud.google.com/logging/docs/api/v2/resource-list).","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoredResourceDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Monitoring","doc":"Monitoring configuration of the service. The example below shows how to configure monitored resources and metrics for monitoring. In the example, a monitored resource and two metrics are defined. The `library.googleapis.com/book/returned_count` metric is sent to both producer and consumer projects, whereas the `library.googleapis.com/book/num_overdue` metric is only sent to the consumer project. monitored_resources: - type: library.googleapis.com/Branch display_name: \"Library Branch\" description: \"A branch of a library.\" launch_stage: GA labels: - key: resource_container description: \"The Cloud container (ie. project id) for the Branch.\" - key: location description: \"The location of the library branch.\" - key: branch_id description: \"The id of the branch.\" metrics: - name: library.googleapis.com/book/returned_count display_name: \"Books Returned\" description: \"The count of books that have been returned.\" launch_stage: GA metric_kind: DELTA value_type: INT64 unit: \"1\" labels: - key: customer_id description: \"The id of the customer.\" - name: library.googleapis.com/book/num_overdue display_name: \"Books Overdue\" description: \"The current number of overdue books.\" launch_stage: GA metric_kind: GAUGE value_type: INT64 unit: \"1\" labels: - key: customer_id description: \"The id of the customer.\" monitoring: producer_destinations: - monitored_resource: library.googleapis.com/Branch metrics: - library.googleapis.com/book/returned_count consumer_destinations: - monitored_resource: library.googleapis.com/Branch metrics: - library.googleapis.com/book/returned_count - library.googleapis.com/book/num_overdue","ref":"GoogleApi.ServiceUsage.V1.Model.Monitoring.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Monitoring","doc":"*   `consumerDestinations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.t)`, *default:* `nil`) - Monitoring configurations for sending metrics to the consumer project. There can be multiple consumer destinations. A monitored resource type may appear in multiple monitoring destinations if different aggregations are needed for different sets of metrics associated with that monitored resource type. A monitored resource and metric pair may only be used once in the Monitoring configuration.\n*   `producerDestinations` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.t)`, *default:* `nil`) - Monitoring configurations for sending metrics to the producer project. There can be multiple producer destinations. A monitored resource type may appear in multiple monitoring destinations if different aggregations are needed for different sets of metrics associated with that monitored resource type. A monitored resource and metric pair may only be used once in the Monitoring configuration.","ref":"GoogleApi.ServiceUsage.V1.Model.Monitoring.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Monitoring.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Monitoring.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Monitoring.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Monitoring.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination","doc":"Configuration of a specific monitoring destination (the producer project or the consumer project).","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.MonitoringDestination","doc":"*   `metrics` (*type:* `list(String.t)`, *default:* `nil`) - Types of the metrics to report to this monitoring destination. Each type must be defined in Service.metrics section.\n*   `monitoredResource` (*type:* `String.t`, *default:* `nil`) - The monitored resource type. The type must be defined in Service.monitored_resources section.","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.MonitoringDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.NodeSettings","doc":"Settings for Node client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.NodeSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.NodeSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceUsage.V1.Model.NodeSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.NodeSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.NodeSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.NodeSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.NodeSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements","doc":"OAuth scopes are a way to define data and permissions on data. For example, there are scopes defined for \"Read-only access to Google Calendar\" and \"Access to Cloud Platform\". Users can consent to a scope for an application, giving it permission to access that data on their behalf. OAuth scope specifications should be fairly coarse grained; a user will need to see and understand the text description of what your scope means. In most cases: use one or at most two OAuth scopes for an entire family of products. If your product has multiple APIs, you should probably be sharing the OAuth scope across all of those APIs. When you need finer grained OAuth consent screens: talk with your product management about how developers will use them in practice. Please note that even though each of the canonical scopes is enough for a request to be accepted and passed to the backend, a request can still fail due to the backend requiring additional scopes or permissions.","ref":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.OAuthRequirements","doc":"*   `canonicalScopes` (*type:* `String.t`, *default:* `nil`) - The list of publicly documented OAuth scopes that are allowed access. An OAuth token containing any of these scopes will be accepted. Example: canonical_scopes: https://www.googleapis.com/auth/calendar, https://www.googleapis.com/auth/calendar.read","ref":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.OAuthRequirements.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Operation","doc":"This resource represents a long-running operation that is the result of a network API call.","ref":"GoogleApi.ServiceUsage.V1.Model.Operation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Operation","doc":"*   `done` (*type:* `boolean()`, *default:* `nil`) - If the value is `false`, it means the operation is still in progress. If `true`, the operation is completed, and either `error` or `response` is available.\n*   `error` (*type:* `GoogleApi.ServiceUsage.V1.Model.Status.t`, *default:* `nil`) - The error result of the operation in case of failure or cancellation.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the `name` should be a resource name ending with `operations/{unique_id}`.\n*   `response` (*type:* `map()`, *default:* `nil`) - The normal, successful response of the operation. If the original method returns no data on success, such as `Delete`, the response is `google.protobuf.Empty`. If the original method is standard `Get`/`Create`/`Update`, the response should be the resource. For other methods, the response should have the type `XxxResponse`, where `Xxx` is the original method name. For example, if the original method name is `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.","ref":"GoogleApi.ServiceUsage.V1.Model.Operation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Operation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Operation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Operation.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Operation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata","doc":"The operation metadata returned for the batchend services operation.","ref":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.OperationMetadata","doc":"*   `resourceNames` (*type:* `list(String.t)`, *default:* `nil`) - The full name of the resources that this operation is directly associated with.","ref":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.OperationMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Option","doc":"A protocol buffer option, which can be attached to a message, field, enumeration, etc.","ref":"GoogleApi.ServiceUsage.V1.Model.Option.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Option","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The option's name. For protobuf built-in options (options defined in descriptor.proto), this is the short name. For example, `\"map_entry\"`. For custom options, it should be the fully-qualified name. For example, `\"google.api.http\"`.\n*   `value` (*type:* `map()`, *default:* `nil`) - The option's value packed in an Any message. If the value is a primitive, the corresponding wrapper type defined in google/protobuf/wrappers.proto should be used. If the value is an enum, it should be stored as an int32 value using the google.protobuf.Int32Value type.","ref":"GoogleApi.ServiceUsage.V1.Model.Option.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Option.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Option.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Option.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Option.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Page","doc":"Represents a documentation page. A page can contain subpages to represent nested documentation set structure.","ref":"GoogleApi.ServiceUsage.V1.Model.Page.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Page","doc":"*   `content` (*type:* `String.t`, *default:* `nil`) - The Markdown content of the page. You can use (== include {path} ==) to include content from a Markdown file. The content can be used to produce the documentation page such as HTML format page.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the page. It will be used as an identity of the page to generate URI of the page, text of the link to this page in navigation, etc. The full page name (start from the root page name to this page concatenated with `.`) can be used as reference to the page in your documentation. For example: pages: - name: Tutorial content: (== include tutorial.md ==) subpages: - name: Java content: (== include tutorial_java.md ==) You can reference `Java` page using Markdown reference link syntax: `Java`.\n*   `subpages` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Page.t)`, *default:* `nil`) - Subpages of this page. The order of subpages specified here will be honored in the generated docset.","ref":"GoogleApi.ServiceUsage.V1.Model.Page.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Page.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Page.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Page.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Page.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.PhpSettings","doc":"Settings for Php client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.PhpSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.PhpSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceUsage.V1.Model.PhpSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.PhpSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.PhpSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.PhpSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.PhpSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Publishing","doc":"This message configures the settings for publishing [Google Cloud Client libraries](https://cloud.google.com/apis/docs/cloud-client-libraries) generated from the service config.","ref":"GoogleApi.ServiceUsage.V1.Model.Publishing.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Publishing","doc":"*   `apiShortName` (*type:* `String.t`, *default:* `nil`) - Used as a tracking tag when collecting data about the APIs developer relations artifacts like docs, packages delivered to package managers, etc. Example: \"speech\".\n*   `codeownerGithubTeams` (*type:* `list(String.t)`, *default:* `nil`) - GitHub teams to be added to CODEOWNERS in the directory in GitHub containing source code for the client libraries for this API.\n*   `docTagPrefix` (*type:* `String.t`, *default:* `nil`) - A prefix used in sample code when demarking regions to be included in documentation.\n*   `documentationUri` (*type:* `String.t`, *default:* `nil`) - Link to product home page. Example: https://cloud.google.com/asset-inventory/docs/overview\n*   `githubLabel` (*type:* `String.t`, *default:* `nil`) - GitHub label to apply to issues and pull requests opened for this API.\n*   `librarySettings` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.ClientLibrarySettings.t)`, *default:* `nil`) - Client library settings. If the same version string appears multiple times in this list, then the last one wins. Settings from earlier settings with the same version string are discarded.\n*   `methodSettings` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MethodSettings.t)`, *default:* `nil`) - A list of API method settings, e.g. the behavior for methods that use the long-running operation pattern.\n*   `newIssueUri` (*type:* `String.t`, *default:* `nil`) - Link to a *public* URI where users can report issues. Example: https://issuetracker.google.com/issues/new?component=190865&template=1161103\n*   `organization` (*type:* `String.t`, *default:* `nil`) - For whom the client library is being published.\n*   `protoReferenceDocumentationUri` (*type:* `String.t`, *default:* `nil`) - Optional link to proto reference documentation. Example: https://cloud.google.com/pubsub/lite/docs/reference/rpc\n*   `restReferenceDocumentationUri` (*type:* `String.t`, *default:* `nil`) - Optional link to REST reference documentation. Example: https://cloud.google.com/pubsub/lite/docs/reference/rest","ref":"GoogleApi.ServiceUsage.V1.Model.Publishing.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Publishing.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Publishing.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Publishing.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Publishing.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.PythonSettings","doc":"Settings for Python client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.PythonSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.PythonSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceUsage.V1.Model.PythonSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.PythonSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.PythonSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.PythonSettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.PythonSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Quota","doc":"Quota configuration helps to achieve fairness and budgeting in service usage. The metric based quota configuration works this way: - The service configuration defines a set of metrics. - For API calls, the quota.metric_rules maps methods to metrics with corresponding costs. - The quota.limits defines limits on the metrics, which will be used for quota checks at runtime. An example quota configuration in yaml format: quota: limits: - name: apiWriteQpsPerProject metric: library.googleapis.com/write_calls unit: \"1/min/{project}\" # rate limit for consumer projects values: STANDARD: 10000 (The metric rules bind all methods to the read_calls metric, except for the UpdateBook and DeleteBook methods. These two methods are mapped to the write_calls metric, with the UpdateBook method consuming at twice rate as the DeleteBook method.) metric_rules: - selector: \"*\" metric_costs: library.googleapis.com/read_calls: 1 - selector: google.example.library.v1.LibraryService.UpdateBook metric_costs: library.googleapis.com/write_calls: 2 - selector: google.example.library.v1.LibraryService.DeleteBook metric_costs: library.googleapis.com/write_calls: 1 Corresponding Metric definition: metrics: - name: library.googleapis.com/read_calls display_name: Read requests metric_kind: DELTA value_type: INT64 - name: library.googleapis.com/write_calls display_name: Write requests metric_kind: DELTA value_type: INT64","ref":"GoogleApi.ServiceUsage.V1.Model.Quota.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Quota","doc":"*   `limits` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.QuotaLimit.t)`, *default:* `nil`) - List of QuotaLimit definitions for the service.\n*   `metricRules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.MetricRule.t)`, *default:* `nil`) - List of MetricRule definitions, each one mapping a selected method to one or more metrics.","ref":"GoogleApi.ServiceUsage.V1.Model.Quota.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Quota.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Quota.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Quota.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Quota.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit","doc":"`QuotaLimit` defines a specific limit that applies over a specified duration for a limit type. There can be at most one limit for a duration and limit type combination defined within a `QuotaGroup`.","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.QuotaLimit","doc":"*   `defaultLimit` (*type:* `String.t`, *default:* `nil`) - Default number of tokens that can be consumed during the specified duration. This is the number of tokens assigned when a client application developer activates the service for his/her project. Specifying a value of 0 will block all requests. This can be used if you are provisioning quota to selected consumers and blocking others. Similarly, a value of -1 will indicate an unlimited quota. No other negative values are allowed. Used by group-based quotas only.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. User-visible, extended description for this quota limit. Should be used only when more context is needed to understand this limit than provided by the limit's display name (see: `display_name`).\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - User-visible display name for this limit. Optional. If not set, the UI will provide a default display name based on the quota configuration. This field can be used to override the default display name generated from the configuration.\n*   `duration` (*type:* `String.t`, *default:* `nil`) - Duration of this limit in textual notation. Must be \"100s\" or \"1d\". Used by group-based quotas only.\n*   `freeTier` (*type:* `String.t`, *default:* `nil`) - Free tier value displayed in the Developers Console for this limit. The free tier is the number of tokens that will be subtracted from the billed amount when billing is enabled. This field can only be set on a limit with duration \"1d\", in a billable group; it is invalid on any other limit. If this field is not set, it defaults to 0, indicating that there is no free tier for this service. Used by group-based quotas only.\n*   `maxLimit` (*type:* `String.t`, *default:* `nil`) - Maximum number of tokens that can be consumed during the specified duration. Client application developers can override the default limit up to this maximum. If specified, this value cannot be set to a value less than the default limit. If not specified, it is set to the default limit. To allow clients to apply overrides with no upper bound, set this to -1, indicating unlimited maximum quota. Used by group-based quotas only.\n*   `metric` (*type:* `String.t`, *default:* `nil`) - The name of the metric this quota limit applies to. The quota limits with the same metric will be checked together during runtime. The metric must be defined within the service config.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the quota limit. The name must be provided, and it must be unique within the service. The name can only include alphanumeric characters as well as '-'. The maximum length of the limit name is 64 characters.\n*   `unit` (*type:* `String.t`, *default:* `nil`) - Specify the unit of the quota limit. It uses the same syntax as Metric.unit. The supported unit kinds are determined by the quota backend system. Here are some examples: * \"1/min/{project}\" for quota per minute per project. Note: the order of unit components is insignificant. The \"1\" at the beginning is required to follow the metric unit syntax.\n*   `values` (*type:* `map()`, *default:* `nil`) - Tiered limit values. You must specify this as a key:value pair, with an integer value that is the maximum number of requests allowed for the specified unit. Currently only STANDARD is supported.","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaLimit.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride","doc":"A quota override","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.QuotaOverride","doc":"*   `adminOverrideAncestor` (*type:* `String.t`, *default:* `nil`) - The resource name of the ancestor that requested the override. For example: `organizations/12345` or `folders/67890`. Used by admin overrides only.\n*   `dimensions` (*type:* `map()`, *default:* `nil`) - If this map is nonempty, then this override applies only to specific values for dimensions defined in the limit unit. For example, an override on a limit with the unit `1/{project}/{region}` could contain an entry with the key `region` and the value `us-east-1`; the override is only applied to quota consumed in that region. This map has the following restrictions: * Keys that are not defined in the limit's unit are not valid keys. Any string appearing in `{brackets}` in the unit (besides `{project}` or `{user}`) is a defined key. * `project` is not a valid key; the project is already specified in the parent resource name. * `user` is not a valid key; the API does not support quota overrides that apply only to a specific user. * If `region` appears as a key, its value must be a valid Cloud region. * If `zone` appears as a key, its value must be a valid Cloud zone. * If any valid key other than `region` or `zone` appears in the map, then all valid keys other than `region` or `zone` must also appear in the map.\n*   `metric` (*type:* `String.t`, *default:* `nil`) - The name of the metric to which this override applies. An example name would be: `compute.googleapis.com/cpus`\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the override. This name is generated by the server when the override is created. Example names would be: `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/adminOverrides/4a3f2c1d` `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/consumerOverrides/4a3f2c1d` The resource name is intended to be opaque and should not be parsed for its component strings, since its representation could change in the future.\n*   `overrideValue` (*type:* `String.t`, *default:* `nil`) - The overriding quota limit value. Can be any nonnegative integer, or -1 (unlimited quota).\n*   `unit` (*type:* `String.t`, *default:* `nil`) - The limit unit of the limit to which this override applies. An example unit would be: `1/{project}/{region}` Note that `{project}` and `{region}` are not placeholders in this example; the literal characters `{` and `}` occur in the string.","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.QuotaOverride.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata","doc":"Metadata for the `RemoveEnableRules` method.","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse","doc":"The response message of `RemoveEnableRules` method.","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse","doc":"*   `parent` (*type:* `String.t`, *default:* `nil`) - The parent consumer policy. It can be `projects/12345/consumerPolicies/default`, or `folders/12345/consumerPolicies/default`, or `organizations/12345/consumerPolicies/default`.\n*   `removedValues` (*type:* `list(String.t)`, *default:* `nil`) - The values removed from the parent consumer policy.","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.RemoveEnableRulesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.RubySettings","doc":"Settings for Ruby client libraries.","ref":"GoogleApi.ServiceUsage.V1.Model.RubySettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.RubySettings","doc":"*   `common` (*type:* `GoogleApi.ServiceUsage.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceUsage.V1.Model.RubySettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.RubySettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.RubySettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.RubySettings.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.RubySettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity","doc":"Service identity for a service. This is the identity that service producer should use to access consumer resources.","ref":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.ServiceIdentity","doc":"*   `email` (*type:* `String.t`, *default:* `nil`) - The email address of the service account that a service producer would use to access consumer resources.\n*   `uniqueId` (*type:* `String.t`, *default:* `nil`) - The unique and stable id of the service account. https://cloud.google.com/iam/reference/rest/v1/projects.serviceAccounts#ServiceAccount","ref":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.ServiceIdentity.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.SourceContext","doc":"`SourceContext` represents information about the source of a protobuf element, like the file in which it is defined.","ref":"GoogleApi.ServiceUsage.V1.Model.SourceContext.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.SourceContext","doc":"*   `fileName` (*type:* `String.t`, *default:* `nil`) - The path-qualified name of the .proto file that contained the associated protobuf element. For example: `\"google/protobuf/source_context.proto\"`.","ref":"GoogleApi.ServiceUsage.V1.Model.SourceContext.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.SourceContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.SourceContext.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.SourceContext.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SourceContext.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.SourceInfo","doc":"Source information used to create a Service Config","ref":"GoogleApi.ServiceUsage.V1.Model.SourceInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.SourceInfo","doc":"*   `sourceFiles` (*type:* `list(map())`, *default:* `nil`) - All files used during config generation.","ref":"GoogleApi.ServiceUsage.V1.Model.SourceInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.SourceInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.SourceInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.SourceInfo.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SourceInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Status","doc":"The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).","ref":"GoogleApi.ServiceUsage.V1.Model.Status.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Status","doc":"*   `code` (*type:* `integer()`, *default:* `nil`) - The status code, which should be an enum value of google.rpc.Code.\n*   `details` (*type:* `list(map())`, *default:* `nil`) - A list of messages that carry the error details. There is a common set of message types for APIs to use.\n*   `message` (*type:* `String.t`, *default:* `nil`) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.","ref":"GoogleApi.ServiceUsage.V1.Model.Status.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Status.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Status.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Status.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Status.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameter","doc":"Define a parameter's name and location. The parameter may be passed as either an HTTP header or a URL query parameter, and if both are passed the behavior is implementation-dependent.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameter.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.SystemParameter","doc":"*   `httpHeader` (*type:* `String.t`, *default:* `nil`) - Define the HTTP header name to use for the parameter. It is case insensitive.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Define the name of the parameter, such as \"api_key\" . It is case sensitive.\n*   `urlQueryParameter` (*type:* `String.t`, *default:* `nil`) - Define the URL query parameter name to use for the parameter. It is case sensitive.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameter.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameter.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameter.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameter.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameter.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule","doc":"Define a system parameter rule mapping system parameter definitions to methods.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.SystemParameterRule","doc":"*   `parameters` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.SystemParameter.t)`, *default:* `nil`) - Define parameters. Multiple names may be defined for a parameter. For a given method call, only one of them should be used. If multiple names are used the behavior is implementation-dependent. If none of the specified names are present the behavior is parameter-dependent.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Use '*' to indicate all methods in all APIs. Refer to selector for syntax details.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameters","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.html"},{"type":"module","title":"System parameter configuration A system parameter is a special kind of parameter defined by the API system, not by an individual API. It is typically mapped to an HTTP header and/or a URL query parameter. This configuration specifies which methods change the names of the system parameters. - GoogleApi.ServiceUsage.V1.Model.SystemParameters","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.html#module-system-parameter-configuration-a-system-parameter-is-a-special-kind-of-parameter-defined-by-the-api-system-not-by-an-individual-api-it-is-typically-mapped-to-an-http-header-and-or-a-url-query-parameter-this-configuration-specifies-which-methods-change-the-names-of-the-system-parameters"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.SystemParameters","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.SystemParameterRule.t)`, *default:* `nil`) - Define system parameters. The parameters defined here will override the default parameters implemented by the system. If this field is missing from the service config, default system parameters will be used. Default system parameters and names is implementation-dependent. Example: define api key for all methods system_parameters rules: - selector: \"*\" parameters: - name: api_key url_query_parameter: api_key Example: define 2 api key names for a specific method. system_parameters rules: - selector: \"/ListShelves\" parameters: - name: api_key http_header: Api-Key1 - name: api_key http_header: Api-Key2 **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.SystemParameters.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Type","doc":"A protocol buffer message type.","ref":"GoogleApi.ServiceUsage.V1.Model.Type.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Type","doc":"*   `edition` (*type:* `String.t`, *default:* `nil`) - The source edition string, only valid when syntax is SYNTAX_EDITIONS.\n*   `fields` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Field.t)`, *default:* `nil`) - The list of fields.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The fully qualified message name.\n*   `oneofs` (*type:* `list(String.t)`, *default:* `nil`) - The list of types appearing in `oneof` definitions in this type.\n*   `options` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.Option.t)`, *default:* `nil`) - The protocol buffer options.\n*   `sourceContext` (*type:* `GoogleApi.ServiceUsage.V1.Model.SourceContext.t`, *default:* `nil`) - The source context.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax.","ref":"GoogleApi.ServiceUsage.V1.Model.Type.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Type.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Type.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Type.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Type.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata","doc":"Metadata message that provides information such as progress, partial failures, and similar information on each GetOperation call of LRO returned by UpdateAdminQuotaPolicy.","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateAdminQuotaPolicyMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata","doc":"Metadata for the `UpdateConsumerPolicy` method.","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.UpdateConsumerPolicyMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.Usage","doc":"Configuration controlling usage of a service.","ref":"GoogleApi.ServiceUsage.V1.Model.Usage.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.Usage","doc":"*   `producerNotificationChannel` (*type:* `String.t`, *default:* `nil`) - The full resource name of a channel used for sending notifications to the service producer. Google Service Management currently only supports [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification channel. To use Google Cloud Pub/Sub as the channel, this must be the name of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format documented in https://cloud.google.com/pubsub/docs/overview.\n*   `requirements` (*type:* `list(String.t)`, *default:* `nil`) - Requirements that must be satisfied before a consumer project can use the service. Each requirement is of the form /; for example 'serviceusage.googleapis.com/billing-enabled'. For Google APIs, a Terms of Service requirement must be included here. Google Cloud APIs must include \"serviceusage.googleapis.com/tos/cloud\". Other Google APIs should include \"serviceusage.googleapis.com/tos/universal\". Additional ToS can be included based on the business needs.\n*   `rules` (*type:* `list(GoogleApi.ServiceUsage.V1.Model.UsageRule.t)`, *default:* `nil`) - A list of usage rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceUsage.V1.Model.Usage.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.Usage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.Usage.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.Usage.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.Usage.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceUsage.V1.Model.UsageRule","doc":"Usage configuration rules for the service. NOTE: Under development. Use this rule to configure unregistered calls for the service. Unregistered calls are calls that do not contain consumer project identity. (Example: calls that do not contain an API key). By default, API methods do not allow unregistered calls, and each method call must be identified by a consumer project identity. Use this rule to allow/disallow unregistered calls. Example of an API that wants to allow unregistered calls for entire service. usage: rules: - selector: \"*\" allow_unregistered_calls: true Example of a method that wants to allow unregistered calls. usage: rules: - selector: \"google.example.library.v1.LibraryService.CreateBook\" allow_unregistered_calls: true","ref":"GoogleApi.ServiceUsage.V1.Model.UsageRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceUsage.V1.Model.UsageRule","doc":"*   `allowUnregisteredCalls` (*type:* `boolean()`, *default:* `nil`) - If true, the selected method allows unregistered calls, e.g. calls that don't identify any user or application.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Use '*' to indicate all methods in all APIs. Refer to selector for syntax details.\n*   `skipServiceControl` (*type:* `boolean()`, *default:* `nil`) - If true, the selected method should skip service control and the control plane features, such as quota and billing, will not be available. This flag is used by Google Cloud Endpoints to bypass checks for internal methods, such as service health check methods.","ref":"GoogleApi.ServiceUsage.V1.Model.UsageRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceUsage.V1.Model.UsageRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceUsage.V1.Model.UsageRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceUsage.V1.Model.UsageRule.t/0","doc":"","ref":"GoogleApi.ServiceUsage.V1.Model.UsageRule.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}